;
;	Siemens C5 - Umbau auf AFU-QRGs
;
;	Uwe Hennig, DL6INT
;
;
;       letzte nderung: 04.07.2001
;
;
;	auf meine DL3ED Ansprche angepasst am Mittwoch, 27. Dezember 2000
;
;	* serielle Kommunikation mit Bedienteil 19200 Baud inkl. Prfbyte beidseitig ok
;	* lesen/schreiben in/aus 24c02 ok
;	* programmieren PLL ok
;	* lesen/schreiben AD/DA-Wandler ok
;	* 10 Hz zum Watchdog ok
;	* ausschalten mit "#" ok
;	* Raster 12.5 kHz ok
;	* Licht-Automatik ok
;	* Frequenzarithmetik und -anzeige ok
;	* VFO, Squelch, Volume save/restore in EEPROM ok
;	* TX-Betrieb mit und ohne Ablage ok
;	* S-Meter + squelch inkl. Einstellung ok, Aktu-Rate 20/Sekunde
;	* Rufton 1755 Hz mit C-Taste ok
;	* Men mit Squelch-Level, Lautstrke, tune-step, U_B, Tx-Pwr ok
;	* bermittlung der S-Meter-Anzeige nur bei nderung der Darstellung ok
;	* 4 x 9 Speicherpltze im EEPROM, programmierbar ber VFO ok
;	* 4stufig einstellbare Sendeleistung, gerettet in EEPROM ok
;	* Abspeicherung Tune-Step ok
;	* externe PTT ok
;	* Abstimmung autorepeat ok
;	* verschiedene Ablagen: 0, +-6.550 +-7.600, +-9.400 ok
;	* Senden nur innerhalb der Bandgrenzen ok
;	* Mem -> VFO ok
;	* Copyright ok
;	* invers empfangen und senden, bei empfangen Rauschsperre offen ok
;	* direkte Frequenzeingabe ok
;	* Lichtmodus: normal: 12s ein, bei genug Spannung immer ein  short: 6s ein ok
;	* Mikrofone aus bei Rufton ok
;	* Rufton macht auch PTT ok
;	* Initialisierung EEPROM ok
;---8h1---
;	* Timing-Problem mit manchen BTs behoben (BusRq jetzt 3.3ms)
;---8i---
;	* variabler S-Meter-Nullpunkt
;	* Lautstrke "0"
;	* Balkenanzeige der Sendeleistungsstufe beim Senden
;	* Hrer- und Sendesymbol beim Senden
;	* Spannungsalarm
;	* Abschaltung bei zu geringer Spannung mit Verzgerung
;	* Temperaturanzeige
;	* Bank-Scan mit lang-1, Relais-Ausgabe-Scan mit lang-2
;	   scan-Anzeige mit blinkendem Schlsselsymbol
;	   scan-Fortsetzung mit UP, Abbruch mit DOWN oder Zahlentaste
;	* vorbereitet: Mic-Verstrker bei packet aus
; ---8i2---
;	* Bugfixes: - Initialisierung von Keycode und Keytime
;	 - Bei 1-9 und Hrer und C wird Menpunkt auf 0 gestellt, auer bei Spannungsanzeige
;	* Ton bei Unterspannungs-Abschaltung (bisher nur bei Warnung)
; ---8i3---
;	* Bugfix: - Sendesymbole bei off-Band nicht anzeigen
;	* Ausschalten mit Ein-/Aus-Taste
;	* S-Meter-Null automatisch auf RSSI-10
;	* S0 wirkt auf S-Meter _und_ Squelch-Level
;	* EEprom-Init durch Tastenkombination, nicht mehr durch Hardware-Pin
; ---8k---
;	* entspricht letzter 8i3
; ---8l---
;	* Klick bei Drcken der Ausschalttaste und weiterer Klick, wenn  Abschaltsequenz gestartet ist
;	* EEPROM-Adressen neu organisiert
;	* nderbare Kurznamen (4 Zeichen) fr Speicher
; ---9a---
;	* Ansteuerung DTMF-Slave ber I2C
;	* Bugfixes: - kein "blindes Men" beim Scannen
;	- auch nach . und .. Men bei volume beginnen
;	- Licht bleibt an bei autorepeat
;	* Schrittweite bei Relais-Ausgabe-Scan entspricht tunestep
;
;---9aa DL3ED ---
;	Relaisablage hinzugefgt 6.550, Ablage 6 stellig.
;	Abschalttext, einen dummen Spruch eingefgt.
;	Texteingabe wie beim Handy die Reihenfolge.
;	Memo Frequenzen gendert.
;	Bei gefneter Rauschsperre wird Lautsprechersimbol angezeigt
;	ASM-Text mit Tab aufgearbeitet fr Word usw.
;	Sql im Hrer, SAPI 7 im btSetup mit NFEnab gesteuert
;	Nf beim Tonruf um 15 db abgesenkt im SAPI 8
;   --- DL6INT ---
;       Anmerkung:Die Squelch im Hrer erzeugt zustzlichen Bus-Traffic und
;       verzgert damit gelegentlich die Tasten-Msg. Auch die Ansprechzeit
;       der packet-ptt kann darunter leiden.
;       * Weitere Ablage +1.6MHz
;       * Squelch-Hysterese
;--- 9a2 ----
;       * Squelch im Hrer wieder entfernt (zu viel Bustraffic)
;       * Bugfix: direkte Frequenzeingabe nach Menwahl ber "*" funktioniert
;         wieder wie in 9a
;       * Reihenfolge der Ablagen wieder wie in 9a, die neuen
;         Ablagen dahinter (somit wieder EEPROM-kompatibel zu 9a)
;--- 9b -----
;       * Bugfix: Bei Aufruf von Scan-Modus wird nun Menpunkt
;         auf 0 gestellt (In Spannungs-/Temperaturmen konnte man
;         den Suchlauf starten und nicht mehr stoppen.)
;       * Tastensperre (KeyLock) durch 4maliges Drcken der Ausschalttaste
;         mit weniger als 800ms Abstand aktivierbar; wird auch in EEPROM
;         gerettet
;       * zustzliches Pin (P3.5) wird Low bei geringster Leistungsstufe,
;         dadurch bessere Verteilung der 4 Leistungsstufen mglich
;--- 9c ------
;       * Weitere Ablage -1.6 MHz
;       * Ausschalten nun auch bei Keylock mglich
;       * Hrkapsel wird beim Senden ausgeschaltet
;--- 9d ------
;       * Symbol fr externe Versorgung


;
; to do:
;	- S-Meter-Kalibrierung verbessern, temperaturkompensieren
;	- Sendezeitbegrenzung
;	- Temperaturalarm
;	- Auto-Power-Off
;
;..........................................................................
;
;	Menpunkte
;	 1. Volume
;	 2. Squelch
;	 3. TuneStep
;	 4. WriteMem    <-- Direktzugriff mit "#"
;	 5. Freq:       <-- Driektzugriff mit "0"
;	 6. TxPower
;	 7. RelShift
;	 8. Light
;	 9. Mem->VFO
;	 10. UBatt
;	 11. Copyright
;	 12. MemName
;
;..........................................................................
;
; Bemerkungen zur Frequenzarithmetik
;
; - Ausgangspunkt der Berechnungen ist der 2 Byte groe Teilerfaktor der
;   PLL im Empfangsfall, also fr f_vfo=f_rx-45000kHz
; - Fr Abgleich und Test sollen f_rx von 420 bis 460 MHz mglich
;   sein, was PLL-Werten von 30000 bis 33200 entspricht.
;   Zur Speicherung dieses Bereiches gengen 12 Bit, der Wert 30000
;   wird als Konstante addiert. Im 16-Bit-Kanal-Memory sind somit die
;   oberen 4 Bit frei zur Kodierung verschiedener Einstellungen.
;
;
;...........................................................................
;
	
	cpu	8051
	include	stddef51.inc	

;--------------------------------------------------------------------------
;	Belegung der Ports:
SCL		equ	P1.7			; SCL (I2C Serial Clock)
SDA		equ	P1.6			; SDA (I2C Serial Data)
WDog		equ	P1.5			; 10 Hz zum Watchdog
TXEnab		equ	P1.4			; Sender-Aktivierung (low-aktiv)
NFEnab		equ	P1.3			; Aktivierung RX-NF-Verstrker (low-aktiv)
EPTT		equ	P1.2			; externe PTT
PwrAdj1		equ	P1.1			; Leistungseinstellung (open drain)
PwrAdj0		equ	P1.0			; Leistungseinstellung (open drain)

LED		equ	P3.7			; Debug-LED
;COMPA	equ	P3.6			; Analogcomparator
PwrAdjL		equ	P3.5			; Leistungseinstellung (Low bei Stufe 0)
;reserve		equ	P3.4
MicOff 		equ	P3.3			; high:Sende-NF-Verarbeitung aus (bei packet)
OnOffOut	equ	P3.2			; Ausschaltleitung
;TXD		equ	P3.1
;RXD		equ	P3.0


;--------------------------------------------------------------------------
;
;	Speicherbelegung
;
;Registerbank 0:					0..7
; Register:					r0: indexregister, hexdigit
;						r1: indexregister
;						r2,r3: Warteschleife, allgemeines
;						r4,r5,r6: Timerinterruptroutine
;						r7: 
;---------------------------------------------------------------------------------------------------------------------------------------

frTeiL		equ		8
frTeiH		equ		9
frqL		equ		10
frqM		equ		11
frqH		equ		12
pBCDL		equ		13
pBCDM		equ		14
pBCDH		equ		15
dlyARep	        equ		16		; Verzgerung des Auto-Repeat
vfoL		equ		17
vfoH		equ		18
tuneStep	equ		19		; VFO-Abstimmraster in 12k5-Schritten

keycode		equ		20
chksum		equ		21
tmp		equ		22
SMet		equ		23
I2CAdr		equ		24		; Device-Adresse I2C, wobei Bit 0 (R/W) automatisch ersetzt wird
I2CCnt		equ		25		; Anzahl zu lesender/schreibender Bytes 
w_adr		equ		26		; Word-Adresse im EEPROM
memNr		equ		27		; Nr des aktuell eingestellten Speichers, 0=vfo

LitCDN		equ		28		; Count-Down fr Displaybeleuchtung (runtergezhlt durch Timer-Interrupt)
squelch		equ		29		; squelch level
MenuCDN	        equ		30		; Count-Down fr Men-Anzeige, runtergezhlt in timer200ms-routine
MenuPnkt 	equ		31		; Nr des gewhlten Menpunkts

bitReg0		equ		32
bitReg1		equ		33
bitReg2		equ		34

frInStat	equ		35		; Statusmerker der Direkteingabe
volume		equ		36		; Lautstrke-Wert (0..7) 0=-20dB(max), 7=0dB(max)
merkMem	        equ		37		; Nr des zuletzt gewhlten Speichers (fr VFO_to_MEM)
merkSMet	equ		38		; gemerktes S-Meter-Bitmap
adc0		equ		39
adc1		equ		40
adc2		equ		41
adc3		equ		42
txpwr		equ		43		; Sendeleistung 0=verylow, 1=low, 2=med, 3=high
memPage	        equ		44		; Speicherbank-Nr (Bits4..5), Bit 7 ist Licht-Modus
s0		equ		45		; AD-Wert fr S-Meter-"Null"
dlyAlarm	equ		46		; Laufvariable fr Alarmverzgerung
ShutDn		equ		47		; Laufvariable fr Shut Down (bei Spannungsmangel)
keyTime		equ		48		; Countdown fr Erkennung von langem Tastendruck
keyCount	equ		49		; Anzahl Tastendrcke fr Nameneingabe
;-----------zusammenhngender Block-------------
memTL		equ		50		; teilerfaktor fr aktuellen Speicherkanal, low-Byte
memTH		equ		51		; dito, high-Byte
memChr0	        equ		52		; Speichername
memChr1	        equ		53		; Speichername
memChr2	        equ		54		; Speichername
memChr3	        equ		55		; Speichername
;---------Ende zusammenhngender Block----------
charPos		equ		56		; Zeichenposition bei Nameneingabe
tmp2            equ             57
nclick          equ             58 ; Anzahl Tastendrcke onoff
tclick          equ             59 ; Timeout fr Mehrfach-Tastendruckerkennung

abuffer		equ		62		; Puffer fr ASCII-Zahlen-String
ibuffer		equ		68		; Puffer fr I2C-Kommunikation
sbuffer		equ		78		; Puffer fr Kommunikation auf SCI-Bus

stack		equ		100

;----  Bitbereich:  -----------------------------------------------------

btSMet		equ	0	; Kennzeichnung, da es Zeit zur S-Meter-Aktualisieung ist
btRXKey	        equ	1	; Kennzeichnung, da Tastencode empfangen wurde
btLiSol		equ	2	; "Soll"-Bit fr Displaybeleuchtung (wird durch
				; Timerinterrupt in Abhngigkeit von LitCDN gesetzt/gelscht)
btLiIst		equ	3	; "Ist"-Bit fr Displaybeleuchtung
btTxRq		equ	4	; "senden" angefordert
btOffBnd	equ	5	; ist 1 auerhalb des AFU-Bandes (nur tx)
bt5pros		equ	6	; wird durch Timerinterrupt 5 mal pro Sekunde auf 1 gesetzt
EPTTm		equ	7	; gemerkter Zustand der externen PTT
btVFOup	        equ	8	; 1 beim Erhhen der VFO-Frequenz
btVFOdn	        equ	9	; 1 beim Verringern der VFO-Frequenz
btInv		equ	10	; 1 bei Invers-Betrieb (rx mit shift, tx ohne)
btTxOld		equ	11	; gemerkter Zustand RX/TX
btTone		equ	12	; Rufton wird gerade ausgegeben
btLeft		equ	13	; Links-Taste ist gedrckt
btRight		equ	14	; Rechts-Taste ist gedrckt
btULow		equ	15	; Batteriespannung gering
btShutD		equ	16	; ShutDown angefordert
btScBank	equ	17	; Bank-Scan aktiv
btScRela	equ	18	; Relais-Ausgabe-Scan aktiv
btScNext	equ	19	; Scan-Fortsetzung erzwingen
btOffAlt	equ	20	; gemerkter Zustand der OnOff-Taste
btSlowI2C	equ	21	; Geschwindigkeitsumschaltung I2C
btKeyLock       equ     22      ; Tastenverriegelung
btExtSup        equ     23      ; externe Spannungsquelle (>10.8 V)
btExtSupAlt     equ     24      ; gemerkter Zustand btExtSup

btTMP		equ		PSW.5		; Flag zur beliebigen Anwendung
btEqual		equ		PSW.1		; Flag zur beliebigen Anwendung


;-------------------------------------------------------------------------

		org	0
		ajmp	reboot
;-------------------------------------------------------------------------
txtTnStp:	db	"TuneStep"
		db	0
;-------------------------------------------------------------------------

		org	0bh			; Interruptadresse timer0

						; Timerinterrupt, 5000 mal pro Sekunde aufgerufen
itime0:		push	acc
		push	psw
		inc	r4
		cjne	r4,#250,it_1		; dieser Programmteil luft 20 mal pro Sekunde:
		mov	r4,#0
		setb	btSMet			; S-Meter-Aktualisierung anstoen
		cpl	WDog			; Hardware-Watchdog fttern
		clr	btLiSol			; erstmal "LichtSoll=aus" annehmen
		mov	A,litCDN
		jz	it_2
		setb	btLiSol			; doch "LichtSoll=ein"
		dec	litCDN			; Licht-countdown verringern
it_2:		inc	r5
		cjne	r5,#4,it_1		; dieser Programmteil luft 5 mal pro Sekunde:
		mov	r5,#0
		setb	bt5pros
it_1:		pop	psw
		pop	acc
		reti

reboot:						; Initialisierung:
						; Stackpointer setzen:
		mov	SP,#STACK		; Variablen:
		clr	A
		mov	r4,#0
		mov	r5,#0
		mov	r6,#0
		mov	SMET,A
		; mov	MenuCDN,A		; wird spter initialisiert
		mov	MenuPnkt,A
		mov	BitReg0,A
		mov	BitReg1,A
		mov	BitReg2,A
		setb	btSlowi2c
		mov	keycode,a
		mov	keytime,a
		mov	dlyAlarm,#2		; n*0.2 s Alarmverzgerung
		mov	C,EPTT
		mov	EPTTm,C		; gemerkte PTT = aktuelle PTT, so da
						; nicht gesendet wird, egal wie PTT steht
                mov     nclick,a
                mov     tclick,a

		; mov	volume,A		; wird aus eeprom gelesen
		; mov	MemNr,#1		; wird aus eeprom gelesen
		; mov	MerkMem,#0		; wird gleich memNr gesetzt
		;mov	lzSup,#0
		; mov	vfoL,#28h
		; mov	vfoH,#7bh		; wird aus eeprom gelesen
		; mov	tuneStep,#1		; tuning step n*12.5 kHz wird aus eeprom gelesen
		;clr	btTxRq ist schon 0
		setb	btTxOld			; NF-Wege im BT beim ersten Aufruf von aktuQRG schalten
		;setb	txEnab			; ist nach reset schon high ; Sender aus
		; mov	squelch,#30		; wird aus eeprom gelesen
		mov	merkSMet,#0ffh		; S-Meter auf jeden Fall neu darstellen
						; btOffAlt ist schon 0, nach Neustart ist gedrckte
						; OnOff-Taste (low) kein Abschaltwunsch
; UART init:
		mov	SCON,#01110000b	; Modus 1
		mov	PCON,#80h		; (SMOD=1)
; Timer init:
		mov	TMOD,#00100010b	; Timer 1: 8-bit-autoreload (fr Serielle)
						; Timer 0: 8-bit-autoreload (fr Uhr)
		mov	TH1,#256-4		; Timer 1: 4 Schritte = 312.5kHz bei xtal 15.00MHz
						; mit SMOD=1 ergeben sich ____19.53 kBaud____
		mov	TH0,#256-250		; Timer 0: 250 Schritte = 5.0 kHz Interrupt-
						; frequenz bei xtal 15.00MHz	
		mov	TCON,#50h		; start timer 1 und 
						; start timer 0
		mov	IE,#82h			; Freigabe Timer-Int 0
; zweimal blinken:
		clr	LED
		call	wait50
		call	voidI2C			; I2C mit Nulldaten fttern
		setb	LED
		call	wait50
		clr	LED
		call	wait50
		call	voidI2C			; I2C mit Nulldaten fttern
		setb	LED
		call	wait50

; Gepiepse:
		call	vorbTon
		call	busRQ
		call	sendStc
		call	wait50

; Einschaltmeldung:
		mov	DPTR,#txtOn
		call	eintrTxt
		call	BusRQ
		call	sendStc
		call	pllInit			; VORSICHT: feste Frequenz, nicht aus Kanal-Speicher!
		call	addaInit

; Squelch aus EEPROM:
		mov	w_adr,#0f0h
		call	eep_rr
		mov	squelch,ibuffer+0
; volume aus EEPROM:
		inc	w_adr ; F1
		call	eep_rr
		mov	volume,ibuffer+0
; memNr aus EEPROM:
		inc	w_adr ; F2
		call	eep_rr
		mov	a,ibuffer+0		; zerlegen in memNr und memPage
		anl	a,#0fh			; Bereichseinschrnkung MemNr (0 bis 15)
		mov	memNr,a
		mov	merkMem,a
		mov	a,ibuffer+0
		anl	a,#0f0h
		mov	memPage,a		; Bit 7 ist Lichtmodus
		anl	a,#80h			; nur Lichtmodus
		orl	a,#7fh			; untere 7 Bit gesetzt
		mov	litCDN,a
; txPwr aus EEPROM
		inc	w_adr			; F3
		call	eep_rr
		mov	txPwr,ibuffer+0
		call	aktuPwr
; tuneStep aus EEPROM
		inc	w_adr			; F4
		call	eep_rr
		mov	tuneStep,ibuffer+0
; S-Meter-Nullwert aus EEPROM
		inc	w_adr			; F5
		call	eep_rr
		mov	s0,ibuffer+0
; VFO aus EEPROM:
		inc	w_adr			; F6
		call	eep_rr
		mov	vfoL,ibuffer+0
		inc	w_adr			; F7
		call	eep_rr
		mov	vfoH,ibuffer+0
; KeyLock-Bit aus EEPROM:
		inc	w_adr			; F8
		call	eep_rr
		mov	a,ibuffer+0
                mov     c,acc.0
                mov     btKeyLock,c

; zum Speicherkanal gehrenden Teilerfaktor aus EEPROM
		call	loadMemT

		mov	MenuCDN,#25		; nach 25/5=5 Sekunden in Normalmodus

; *********************************************************************
; ********************** Hauptschleife ********************************
; *********************************************************************
idle:		call	checkEPTT
		jb	SCON.0,sciRX_
		jbc	btSMet,aktuSMet_
		jbc	btRXKey,handleK_	; Licht schalten, wenn "ist" ungleich "soll"
		jb	btLiSol,idl001
		jb	btLiIst,switLit_
		sjmp	idl002

idl001:		jnb	btLiIst,switLit_

idl002:		jbc	bt5pros,timer200ms
		sjmp	idle	

;**************************************************************************
;	 "Sprungbrett"
;**************************************************************************

sciRX_:		ajmp	sciRX
handleK_:	ajmp	handleK
aktuSMet_:	ajmp	aktuSMet
switLit_:	call	BtSetup
		sjmp	idle

;**************************************************************************
;  hier wird alle 200 ms hingesprungen, wenn nichts anderes anliegt
;**************************************************************************

timer200ms:     mov     a,tclick  ; Timeout fr Mehrfachtastendruck
                jz      ti200_t1  ; ist schon 0 -> fertig
                dec     tclick    ; verringern
                dec     a
                jnz     ti200_t1  ; immer noch nicht 0 -> fertig
                ; timeout gerade abgelaufen
                mov     nclick,#0 ; Anzahl Tastendrcke = 0 setzen
ti200_t1:
                mov	a,MenuPnkt		; Menpunkt
		cjne	a,#12,ti200_2a
		sjmp	ti200_1			; bei MemName keine Rckschaltung nach 5s

ti200_2a:	cjne	a,#10,ti200_2	; ADC-Anzeige laufend aktualisieren
		call	menuDisp

ti200_2:	mov	a,MenuCDN	; Countdown Men-Anzeige
		jz	ti200_1		; ist 0 -> nix tun; sonst:
		dec	MenuCDN		;  verringern
		mov	a,MenuCDN
		jnz	ti200_1		; immer noch nicht 0 -> nix tun; sonst:
					; Men-Zeit abgelaufen
		call	mWegFkt
		mov	MenuPnkt,#0	; Menpunkt "kein Menpukt"
		call	aktuQRG		; Normalanzeige (QRG)

ti200_1:	call	chkAlarm	; Alarm-Status auswerten
		; Shut-Down auswerten
		jnb	btShutD,ti200_1f
		dec	shutDn
		mov	a,shutDn
		jnz	ti200_1g	; Nun wird abgeschaltet
		; Ausschalt-Ton
		call	vorbTon
		mov	sbuffer+4,#208	; Tonhhe
		mov	sbuffer+6,#0fh	; Tonlnge
		mov	sbuffer+8,#2	; Tonanzahl
		call	busRq
		call	sendStc
		call	wait50
		call	wait50
		call	wait50
		ajmp	aus			; Einstellungen _nicht_ retten, weil Spannung
						; whrend des abspeicherns ausfallen knnte

ti200_1f:	mov	shutDn,#200		; 40 Sekunden

ti200_1g:	call	chkLongKey		; langen Tastendruck prfen
		call	chkScan			; Auto-Repeat prfen:
		mov	a,dlyARep
		jz	ti200_3
		dec	dlyARep

ti200_5:ajmp	idle				; Auto-Repeat-Funktion der Up/Down-Tasten:

ti200_3:	jnb	btVFOup,ti200_4
		mov	litCDN,#20		; Licht bleibt an (mu nur bis zum nchsten
						; autorepeat bzw. bis zum loslassen der Taste
						; reichen, dann wird litCDN neu gesetzt)
	      	ajmp	vfoUp
ti200_4:	jnb	btVFOdn,ti200_5
		mov	litCDN,#20
		ajmp	vfoDn

;**************************************************************************
;
;  Sentence vom SCI-Bus empfangen
;***************************************************************************

sciRX:		mov	chksum,#0
		call	rxbyte
		cjne	A,#01ah,idle_
		xrl	chksum,A
rx__1:		jnb	SCON.0,rx__1
		call	rxbyte
		cjne	A,#000h,idle_ 
		xrl	chksum,A
		clr	btVFOup		; autorepeat abschalten
		clr	btVFOdn		;       - || -
rx__2:		jnb	SCON.0,rx__2
		call	rxbyte
		cjne	A,#007h,idle_
		xrl	chksum,A
rx__3:		jnb	SCON.0,rx__3
		call	rxbyte
		cjne	A,#02eh,idle_
		xrl	chksum,A
rx__4:		jnb	SCON.0,rx__4
		call	rxbyte
		cjne	A,#001h,idle_
		xrl	chksum,A
rx__5:		jnb	SCON.0,rx__5
		call	rxbyte
		mov	keycode,A
		xrl	chksum,A
rx__6:		jnb	SCON.0,rx__6
		call	rxbyte			; empfangene Prfsumme
		xrl	A,chksum		; mu mit berechneter 0 ergeben
		jnz	idle_ 			; bei Fehler wieder neu beginnen
						; ok, gltiger Sentence wurde empfangen
		setb	btRXKey
						; also Licht-Countdown reseten:
		mov	a,memPage		; Licht-Modus in Bit 7
		anl	a,#80h
		orl	a,#7fh
		mov	litCDN,a
		call	wait5			; hier 5 Millisekunden vertrdeln:
						; und Besttigung senden:
		mov	sbuffer+0,#000h
		mov	sbuffer+1,#01ah
		mov	sbuffer+2,#005h
		mov	sbuffer+3,#010h
		call	sendStc
		clr	SCON.0			; RX-Interrupt-Bit lschen
		call	wait50			; erforderliche Ruhezeit fr BT-Controller
idle_		ajmp	idle

;*************************************************************************
;
;	check External PTT
;
;	Prft den Status der externen PTT-Leitung
;***************************************************************************

checkEPTT:	mov	c,EPTT
		orl	c,EPTTm
		jnc	chkE01	; beides Null -> nichts tun
		mov	c,EPTT
		anl	c,EPTTm
		jc	chkE01	; beides Eins -> nichts tun
						; gemerkte und aktuelle externe PTT sind verschieden
		mov	c,EPTT
		mov	EPTTm,c ; gemerkte=aktuelle
		jc	chkE02
						; Null, also PTT gerade aktiv geworden
		setb	MicOff 			; Mikrofonverstrker aus, da packet-Betrieb
		setb	btTxRq			; Zustand merken
		setb	nfEnab			; NF-Endstufe aus
		call	aktuQRG		; PLL, Display, Sender, Audiopfad

chkE01:		ret

chkE02:						; PTT gerade inaktiv geworden
		clr	btTxRq			; Zustand merken
		call	aktuQRG		; Sender, PLL, Display, Audiopfad
		ret

;**************************************************************************
;
; "S-Meter aktualisieren"
;
;  d.h. * ADC lesen
;          * nach squelch level und "Volume 0" bewerten und NF-Verstrker de-/aktivieren
;**************************************************************************

aktuSMet:	call	chkOnOff		; Taste 20mal pro Sekunde prfen
		call	ADC_rd			; in adc0 steht S-Meter-Wert ca. 40 bis ca. 228
						; in adc2 steht Versorungsspannung
                call    chkExtSup               ; Externe Spannungsquelle?
		mov	a,adc2
		jz	akSM0c			; Spannung=0 -> nicht verdrahtet, also nichts tun

		; Spannung>0
		; bei Spannung<8.4 V=1.05V/Zelle=134 Alarm geben
		cjne	a,#134,$+3
		mov	btULow,C
		jc	akSM0e		; grer 8.4 -> Abschaltung anullieren
		clr	btShutD
akSM0e:		cjne	a,#123,$+3	; bei Spannung<7.7 V Abschaltung aktivieren
		jnc	akSM0c
		setb	btShutD
akSM0c:		jb	TXEnab,akSM00
                ; beim Senden gibt's kein S-Meter, sondern TX-Level-Anzeige
		mov	TMP,#2		; kein Rahmen, erstes Segment an
		mov	a,txPwr
akSM0b:		jz	akSM0a
		mov	b,a
		mov	a,tmp
		rl	a		; Segmente eins weiter schieben...
		orl	a,#2		; und erstes anknipsen
		mov	tmp,a
		mov	a,b
		dec	a
		sjmp	akSM0b

akSM0a:		sjmp	akSM2		; Bitmap in TMP

akSM00:         ; bei Empfang:
                mov	a,volume	; Volume=0 auswerten
		cjne	a,#1,$+3
                mov	btTMP,C		; ist gesetzt bei Volume=0
                mov     a,squelch       ; Schwelle
                jnb     nfEnab,akSM21b
                ; NF ist aus
                add     a,#3  ; bei ausgeschalteter NF die Schwelle hher setzen,
                              ; um Squelch-Hysterese zu erzeugen
akSM21b:        mov     tmp2,a
                mov     b,adc0 ; RSSI
		mov	TMP,s0	; RSSI mit squelch-level vergleichen:
		; wenn mglich, s0 Einheiten von RSSI abziehen
akSM5:		mov	a,b
		jz	akSM4
		dec	b
		dec	TMP
		mov	a,TMP
		jnz	akSM5

akSM4:		mov	a,B	; B enthlt umgerechneten RSSI-Wert (ca.0 bei freiem Kanal)
		cjne	a,tmp2,$+3  ; mit hysterese-beaufschlagter Schwelle vergleichen
		anl	C,/btInv    ; bei Invers RX Rauschsperre ffnen
		orl	C,btTMP	    ; bei Volume=0 stummschalten
		anl	C,/btOffBnd ; bei OffBand-Tx-Versuch einschalten, damit es pfeift
		mov	NFEnab,C    ; NF-Verstrker de- bzw. aktivieren

                mov	TMP,#0	; kein Balken
                ; oben begrenzen, da hohe Werte nur bei extremen Feldstrken
                ; erreicht werden:
                mov	a,B
                cjne	a,#100,$+3
 		jc	akSM7
		mov	B,#100
akSM7:		; Balkenanzeige berechnen:
akSM3:		mov	a,B
		cjne	a,#15,$+3
      		jc	akSM2	; weniger als 15 brig ->fertig
		; noch mehr als 15 brig -> subtrahieren
		; (carry ist schon null)
		subb	a,#15
		mov	B,a
		mov	a,TMP
		setb	C
		rlc	a			; ein Balken mehr
		mov	TMP,a
		sjmp	akSM3

akSM2:		mov	a,TMP
		mov	c,NFEnab		; Lautsprechersimbol Merker
		mov	acc.7,c
		anl	a,#0bfh			;*********** war 3fh ********************
		cjne	a,merkSMet,akSM9 ; hat sich gendert
                ; Bitmap hat sich nicht gendert -> nix tun
		ajmp	idle

akSM9:          ; hat sich gendert -> neu darstellen
                mov	merkSMet,a              ; neue Bitmap merken
		mov	sbuffer+0,#000h		
		mov	sbuffer+1,#01ah
		mov	sbuffer+2,#00ch
		mov	sbuffer+3,#006h	;SAPI 6
		anl	a,#3fh		;sonst ist Symbol TAE an
		mov	sbuffer+5,a	; <--- Bits 1 bis 5 sind S-Meter, Bit 0 (leere
					; Balkenanzeige) als erste Stufe genutzt
		clr	a
		mov	c,NFEnab
		cpl	c
		mov	acc.3,c		; Lautsprechersymbol
		mov	c,TxEnab	; 0 bei TX
		cpl	c
		mov	acc.4,c		; Hrersymbol
		mov	acc.5,c		; Sendesymbol
		mov	c,btScBank
		orl	c,btScRela
		mov	acc.1,c		; Ausgangs-Symbol (Bit 1) als Scan-Anzeige
                mov     c,btKeyLock
                mov     acc.0,c         ; Schlssel (Bit 0) als Keylock
                mov     c,btExtSup
                mov     acc.2,c         ; Eingangssymbol (Bit2) = externe Versorgung
                mov	sbuffer+4,a
		mov	sbuffer+6,#000h
                anl	a,#2
		mov	sbuffer+7,a	 ; <-- Bit 1 Ausgang blink
		mov	sbuffer+8,#000h
		mov	sbuffer+9,#000h

		mov	sbuffer+10,#0
		call	busRQ
		call	sendStc
		ajmp	idle

;**********************************************************************
;
; Handle Keycode
;

handleK:	mov	keyTime,#10		; 2 Sekunden
		mov	dlyARep,#4
		call	chkDTMF
		mov	A,keycode
		jz	idle__			; ist bereits durch DTMF bearbeitet worden
		cjne	A,#'#',haK001
;------- '#' ---------------------------------------------
                jb      btKeyLock,idle__
		mov	menuPnkt,#4		; Menpunkt WriteMem whlen
		call	menuDisp		; diesen Menpunkt anzeigen
		sjmp    idle__

haK001:		cjne	A,#'0',haK002

haK002:		jc	haK003			; Tastencode<'0'
		cjne	A,#'9'+1,haK002a
haK002a:	jnc	haK003			; Tastencode>'9'
; ----- Bereich '0' bis '9' ---------------------------------
                jb      btKeyLock,idle__
		call	scanAbort
		jc	idle__
		clr	c
		subb	a,#'0'			; ASCII in Binr
		mov	b,a			; Tastencode 0 bis 9 in B
		mov	a,MenuPnkt
		cjne	a,#5,haK002b		; bei Frequenzeingabe Extrabehandlung
		ajmp	frqInput

haK002b:	cjne	a,#12,haK002d		; bei Nameneingabe Extrabehandlung
		ajmp	namInput

haK002d:	 mov	a,b			; Normalfall: Speicherwahl 1 bis 9,
		 jz	haK002c			; Null -> schnell zum Menpunkt Frequenzeingabe
						; 1 bis 9
		mov	MemNr,a
		mov	MerkMem,a
		call	MenuWeg
		call	loadMemT		; Teilerfaktor fr den Speicherkanal aus EEPROM holen
		call	aktuQRG
idle__		ajmp	idle

haK002c:	mov	frInStat,#0		; Status der Frequenzeingabe initialisieren
		mov	menuPnkt,#5		; Menpunkt Frequenzeingabe whlen
		call	menuDisp		; diesen Menpunkt anzeigen
		sjmp	idle__

hak003:		cjne	A,#3fh,haK004		; up
; -------- up ---------------------------
                jb      btKeyLock,idle__
		mov	c,btScBank
		orl	c,btScRela
		jc	hak003a			; in Scan-Modi ist up-Taste die Fortsetzungstaste
		mov	A,memNr
		jnz	hak006			; es war nicht vfo eingestellt -> f nicht ndern
		mov	A,menuPnkt
		jnz	hak006			; es war Men aktiv -> f nicht ndern

vfoUp:		mov	A,tuneStep
		mov	B,#0
		call	addVFO
		setb	btVFOup

hak006:		clr	a
		mov	memNr,a
		mov	menuPnkt,a
		call	aktuQRG
idle___		sjmp	idle__

hak003a:		setb	btScNext		; Scan-Fortsetzung
		sjmp	idle___

hak004:		cjne	A,#3dh,hak005		; down
; ------ down --------------------------------------------
                jb      btKeyLock,idle___
		call	scanAbort
		jc	idle___
		mov	A,memNr
		jnz	hak006			; es war nicht vfo eingestellt -> f nicht ndern
		mov	A,menuPnkt
		jnz	hak006			; es war Men aktiv -> f nicht ndern
vfoDn:		mov	a,tuneStep
		cpl	a			; Zweier-
		inc	a			; komplement
		mov	B,#0ffh
		call	addvfo
		setb	btVFOdn
		sjmp	hak006

hak005:	
hak005a:
hak005b:	cjne	A,#4bh,hak005c		; left
		ajmp	menuDown
hak005c:	cjne	A,#0cbh,hak007		; left loslassen
		clr     btLeft
		ajmp	idle

hak007:		cjne	A,#21h,hak007a		; right
		ajmp	menuUp

hak007a:	cjne	A,#0a1h,hak008		; right loslassen
		clr	btRight
		ajmp	idle

hak008:		cjne	A,#3eh,hak009		; Hrer

hak008a:	call	MenuWeg
		clr	MicOff			; Mikrofonverstrker ein
		setb	btTxRq			; Zustand "Senden" merken
		setb	NfEnab			; NF-Endstufe aus
		call	aktuQRG		; PLL, Anzeige, Sender, NF-Pfad
		sjmp	idle___	

hak009:		cjne	A,#0beh,hak010		; Hrer loslassen

hak009a:		clr	btTxRq			; Zustand "nicht senden" merken
		call	aktuQRG		; Sender, PLL, Anzeige, NF-Pfad
		sjmp	idle___			; NF-Endstufe wird durch S-Meter-Routine geschaltet

hak010:		cjne	A,#03bh,hak011		; ein Punkt -> Speicherseiten-Umschaltung
                jb      btKeyLock,idle___
		call	menuWeg
		mov	A,memNr
		jz	idle___			; im VFO-Modus keine Seitenumschaltung
		mov	a,memPage
		mov	b,a			; Licht-Modus (Bit 7) retten
		add	a,#10h
		anl	a,#30h			; nur 4 Seiten
		mov	c,b.7
		mov	acc.7,c			; Lichtmodus wieder eintragen
		mov	memPage,a
		call	loadMemT
		call	aktuQRG
		sjmp	idle___

hak011:		cjne	A,#03ch,hak011a		; zwei Punkte -> invers
		call	menuWeg
		setb	btInv
		call	aktuQRG
		sjmp	idle_5

hak011a:	cjne	a,#0bch,hak012		; zwei Punkte loslassen -> nicht invers
		clr	btInv
		call	aktuQRG

idle_5:		ajmp	idle
hak012:
hak014:		cjne	A,#03ah,hak015		; "C" -> call-tone
		call	MenuWeg
		setb	btTone
		call	BtSetup
		call	vorbTon
		mov	sbuffer+4,#186		; (256-186)*8.138 -> 1755 Hz 
		mov	sbuffer+5,#04fh
		mov	sbuffer+8,#001h		; 1 Ton
		mov	sbuffer+9,#021h		; enable, Dauerton, Tastenklick, Leise -15 db ****************************
		call	busRQ
		call	sendStc
		sjmp	hak008a			; wie Sendetaste

hak015:		cjne	A,#0bah,hak016		; "C" loslassen
		clr	btTone
		call	BTSetup
		call	vorbTon
		mov	sbuffer+9,#010h		; disable, Tastenklick
		call	busRQ
		call	sendStc
		sjmp	hak009a			; wie Sendetaste loslassen

hak016:		cjne	A,#'*',hak017		; "*" -> men
                jb      btKeyLock,idle_5
		ajmp	NextMenu

hak017:
idle_6:		sjmp	idle_5
;----------------------------------------------------------------------
frqInput:
        ; Tastenwert 0 bis 9 steht in B
	; Tastencode "0" bis "9" steht in keycode
        mov     menuCDN,#25
        mov     a,frInStat
        inc     frInStat
        jz      frqIn_0
        dec     a
        jz      frqIn_1
; frInStat=2, also 10-kHz-Stelle eingetippt
        mov     sbuffer+17,keycode
	mov	a,b
	jb	acc.3,frqIn_b ; 8 oder 9
	jnb	acc.2,frqIn_c ; 0 bis 3 bleibt so
	; 4 bis 7 wird um 1 verringert
	add	a,#0ffh
	sjmp	frqIn_c
frqIn_b: ; 8 oder 9 gedrckt -> 87.5 -> 7
	mov	a,#7
frqIn_c:
	mov	b,#0
	call	addVFO

	mov	menuCDN,#1
        sjmp    idle_6
frqIn_0: ; MHz-Stelle eingetippt
	mov	memNr,#0 ; in VFO-Modus gehen, wenn Frequenz eingegeben wird
        mov     sbuffer+14,keycode
	mov	a,vfoH
	anl	a,#0f0h ; Duplex-Bits bleiben unverndert
	; 430 MHz sind 0x0320
	orl	a,#3
	mov	vfoH,a
	mov	vfoL,#20h
	; 1 MHz sin 0x0050
	mov	a,#50h
	mul	ab
	; n*50h steht in B##A
	call	addVFO
        sjmp    frqIn_a
frqIn_1: ; 100-kHz-Stelle eingetippt
        mov     sbuffer+16,keycode
	; 100 kHz sind 0x0008
	mov	a,#8
	mul	ab
	; n*8 steht in B##A
	call	addVFO
frqIn_a:
        ; im hinteren Teil des Sendepuffers steht noch der
        ; Frequenz-String, der vordere Teil wurde durch
        ;  - Besttigung der Tastennachricht
	;  - S-Meter-Nachricht
	; berschrieben
        mov     sbuffer+2,#15h ; Lnge
        mov     sbuffer+3,#02h ; "Textnachricht"

	mov	sbuffer+4,#'Q'
	mov	sbuffer+5,#'R'
	mov	sbuffer+6,#'G'
	mov	sbuffer+7,#':'

        call    busRQ
        call    sendStc
idle_7: sjmp    idle_6
;-----------------------------------------------------------------
namInput:
        ; Tastenwert 0 bis 9 steht in B
	; Tastencode "0" bis "9" steht in keycode
        mov     a,#7
        mul     ab           ; 7 * Tastenwert
        add     a,keycount   ; + Anzahl der Tastendrcke
        mov     DPTR,#charTab ; Tabellenanfang
        movc    a,@a+DPTR    ; Zeichen aus Tabelle holen
        mov     b,a          ; und zwischenmerken
        mov     a,#memChr0   ; Anfang der Zeichenkette
        add     a,charPos    ; plus Position
        mov     r0,a
        mov     @r0,b        ; Zeichen dorthin speichern
        call    menuDisp     ; Text ausgeben
        ; und Tastenzhler weiterstellen
        inc     keycount
        mov     a,keycount
        cjne    a,#7,naI_b
        mov     keycount,#0
naI_b:
        sjmp    idle_7


;***********************************************************************
;
;  Ausschaltsequenz
;
bye:
        call    vorbTon
        mov     sbuffer+6,#4 ; Lnge
        mov     sbuffer+8,#1 ; Anzahl
        call    busRq
        call    sendStc
        call    wait50
        setb    btLiSol ; Licht einschalten beim Ausschalten
        call    btsetup
	mov	DPTR,#txtQRT ; QRT
	call	eintrTxt
	call	busRQ
	call	sendStc
	call	eep_wrAll ; Einstellwerte retten
aus:	; ausschalten durch interrupt-abklemmen:
	clr	EA
	; und Endlos-Schleife
nothing:sjmp nothing


;***********************************************************************
;
;   Check DTMF
;
;   Prfen, ob Tastendruck als DTMF ausgegeben werden soll
chkDTMF:
        ; nur beim Senden wird DTMF ausgegeben
        jb      txenab,cDTMFx

        mov     dptr,#DTMFtab ; Basisadresse
        mov     b,#0 ; Offset
cDTMF1:
        mov     a,b
        movc    a,@a+dptr
        cjne    a,keycode,cDTMF2
        ; Tastencode in Tabelle gefunden, Tabellenoffset entspricht nun
        ; dem DTMF-Code.
        mov     a,b
        swap    a  ; Slave erwartet den Code in den Bits 7 bis 4
        call    DTMF_WR
        ; Tastencode lschen, da er nicht weiter verarbeitet werden darf
        mov     keycode,#0
        ret ; und fertig
cDTMF2:
        inc     b
        mov     a,b
        cjne    a,#16,cDTMF1
        ; Der Tastencode konnte keinem DTMF-Code 0..15 zugordnet werden.
        ; Also nichts tun und fertig.
cDTMFx: ret


;***********************************************************************
;
;   Check External Supply
;
;   Anhand der Versorgungsspannung prfen, ob Gert extern versorgt wird
;
chkExtSup:
       mov      a,adc2
       cjne     a,#174,$+3      ; ab 10.9 V = 174 soll Licht an sein
       jc       ExtSupNo	; bei kleiner Spannung ist carry gesetzt
ExtSupYes:
       ; wird extern versorgt
       mov      a,memPage	; Licht-Modus in Bit 7
       jnb	acc.7,ExtSupY2	; Spannung hoch genug und LichtModus=1 -> Licht-Countdown reseten:
       mov	litCDN,#0ffh
ExtSupY2:
       jb       btExtSup,ExtSupEnd
       ; Bit war gelscht -> Supply gerade angeklemmt
       setb     btExtSup
       mov      MerkSMet,#0ffh ; Neudarstellung der Symbole
       sjmp     ExtSupEnd

ExtSupNo:
       ; keine externe Versorgung
       jnb       btExtSup,ExtSupEnd
       ; Bit war gesetzt -> Supply gerade abgeklemmt
       clr       btExtSup
       mov       MerkSMet,#0ffh ; Neudarstellung der Symbole
ExtSupEnd:
       ret

;***********************************************************************
;
;  "Men-Weg-Funktionen"
;
;  Ausfhrung von Spezialfunktionen, wenn whrend des zeitgesteuerten
;  Verschwinden des Mens bestimmte Tasten gedrckt sind
;
mWegFkt:
        jnb     btLeft,mWegF99
        jnb     btRight,mWegF99
        ; Rechts und Links sind gedrckt
        clr     btLeft
        clr     btRight

        mov     a,MenuPnkt
        cjne    a,#2,mWegF2
        ; es war Squelch-Men -> S0 auf RSSI-10 setzen
        mov     a,adc0
        add     a,#246 ; -10
        jc      mWegF1a
        ; bei Addition von 246 ist kein berlauf aufgetreten,
        ; also war 0<=RSSI<10, also auf 0 setzen
        clr     a
mWegF1a:
        mov     s0,a
        ret
mWegF2:
        cjne    a,#11,mWegF3
        ; es war Copyright-Men -> EEprom-Init
        jmp   EeInit ; (ohne Rckkehr)
mWegF3:

mWegF99:
        ret

;***********************************************************************
;
;  Check On/Off-Taste
;
;  Wertet nderungen des On/Off-Taste aus, und setzt keytime und keycode
;  entsprechend.
;
chkOnOff:
       clr     a
       mov     B,a
       mov     c,OnOffOut
       mov     B.0,c
       mov     c,btOffAlt
       mov     acc.0,c
       xrl     a,B
       jz      chOO1 ; keine Aenderung->fertig
       jc      chOO2 ; Alt=1 und Neu=0->gerade gedrueckt
       ; Alt=0 und Neu=1 -> gerade losgelassen
       mov     keytime,#0
       sjmp    chOO3
chOO2:
       ; simulierter Tastenklick fuer Ausschalttaste
       call    vorbTon
       mov     sbuffer+4,#160
       mov     sbuffer+6,#2 ; Laenge
       mov     sbuffer+8,#1 ; Anzahl
       call    busRq
       call    sendStc
       call    wait50
       mov     keytime,#3 ; 3*0.2=0.6 Sekunden
       mov     keycode,#0ffh ; "Ausschalt-Taste"
       ; Variablen fuer Erkennung des Mehrfachdrucks der Ausschalttaste setzen
       mov     tclick,#4 ; innerhalb 4*0.2 Sekunden mu naechster click kommen
       inc     nclick
       mov     a,nclick
       cjne    a,#4,chOO3 ; Anzahl erreicht?
       mov     nclick,#0
       cpl     btKeyLock
       mov     merkSMet,#0ffh ; Symbole zum Display uebertragen
chOO3:
       cpl     btOffAlt ; Alt=Neu
chOO1:
       ret


;***********************************************************************
;
; scanAbort
;   bricht Scan ab
;   meldet mit Carry=1, da scan ueberhaupt aktiv war
;
scanAbort:
        mov     c,btScBank
        orl     c,btScRela
        clr     btScBank
        clr     btScRela
        jnc     scAbrt1
        mov     merkSMet,#0ffh ; wenn Scan aktiv war, dann S-Meter-
                   ; neuzeichen erzwingen, weil dadurch auch Scan-
                   ; Symbolik ausgeschaltet wird
scAbrt1:
        ret

;***********************************************************************
;
; MenuWeg
;
; Stellt den MenuPunkt auf 0 (=kein Menpunkt), auer, wenn die
; Spannungsanzeige aktiv ist
;
MenuWeg:
        mov     a,menuPnkt
        cjne    a,#10,MenuWg1
        ret
menuWg1:mov     menuPnkt,#0
        ret

;***********************************************************************
;
; chkAlarm
; Alarm-Status auswerten
;
chkAlarm:
        jnb     btULow,chAla3 ; kein Alarm -> nichts tun
        mov     a,dlyAlarm
        jz      chAla2 ; wenn 0 -> sofort alarmieren
        dec     dlyAlarm ; sonst nur 'runterzhlen
        ret
chAla3:
        mov     dlyAlarm,#10 ; n*0.2 s Alarmverzgerung fr's nchste Mal
        ret
chAla2:
        call    uAlarm  ; Alarm ausgeben
        mov     dlyAlarm,#75 ; nchster Alarm in n*0.2 Sekunden
        mov     litCDN,#100
        ret

;**********************************************************************
;
; Check Long Key
; langen Tastendruck prfen
;
; keyTime wird, wenn >0, eins verringert. Wenn nun 0, dann wird
; keyCode ausgewertet.
;
chkLongKey:
        mov      a,keytime
        jz       chLK99
        dec      keytime
        mov      a,keytime
        jnz      chLK99
        ; Gerade Null geworden, in keycode steht der Tastencode der
        ; zuletzt gedrckten oder auch losgelassenen Taste. Dieses
        ; letzte Tastenereignis liegt 2 Sekunden (bzw 0.6 s bei
        ; OFF-Taste) zurck.
        mov      a,keycode
        cjne     a,#'1',chLK1
        ; Bank-Scan
        jb       btKeyLock,chLK99
        mov      menuPnkt,#0  ; _jedes_ Men verlassen (auch Spannungsanzeige)
        setb     btScBank
chLKSc: mov      merkSMet,#0ffh ; S-Meter-Aktualisierung, damit Scan-Symbol
                                ; aktiviert wird
        ret
chLK1:
        cjne     a,#'2',chLK2
        ; Relais-Ausgabe-Scan
        jb       btKeyLock,chLK99
        mov      menuPnkt,#0  ; _jedes_ Men verlassen (auch Spannungsanzeige)
        setb     btScRela
        mov      a,vfoH
        orl      a,#0fh ; vfo so hoch setzen, da scan auf richtiger
                        ; Untergrenze geginnen mu
        mov      vfoH,a
        sjmp     chLKSc
chLK2:
        cjne     a,#0ffh,chLK3
        ; Off-Taste
        ajmp     bye ; Einstellungen retten, Ausschaltmeldung, und AUS.
chLK3:
chLK99:
        ret

;**********************************************************************
;
;  Check Scan
;  Prft, ob ein Scan-Modus aktiv ist und leitet ggf.weitere Aktionen ein
;
chkScan:
        mov      c,btScBank
        orl      c,btScRela
        jc       chScn2
        ret
chScn2: ; Ein Scan-Modus ist aktiv
        jb       NFEnab,chScn4 ; High=NF-aus=kein Signal=weiterscannen
        ; Signal hher als Rauschsperre
        jb       btScNext,chScn4 ; Zwangsweiterschaltung
        ret
chScn4:
        clr      btScNext ; Zwangsweiterschaltung quittieren
        call     menuWeg  ; etwaigen Menmodus beenden, so da
                          ; die *-Taste whrend des Scannens wirkungslos
                          ; bleibt, auer, wenn der Scanner angehalten hat.
        jb       btScBank,ScBank
        jb       btScRela,ScRela
        ret

ScRela: ; Scannen auf dem Relais-Ausgabe-Bereich
        mov      TMP,vfoH ; Duplex-Index retten
        mov      memNr,#0 ; vfo whlen
        mov      a,vfoL
        add      a,tunestep
        mov      vfoL,a
        mov      a,vfoH
        addc     a,#0
        anl      a,#0fh ; ohne Duplex-Index
        mov      vfoH,a
        mov      b,a
        ; Obergrenze prfen
        ; 440.000 = 1600 = 0640h
        ; 438.600 = 1488 = 05d0h
        mov      a,vfoL
        mov      DPTR,#1600
        call     vgl16
        jc       ScR1
        ; QRG ist >=440.000
        mov      vfoH,#005h
        mov      vfoL,#0d0h
ScR1:   mov      a,TMP
        anl      a,#0f0h ; nur Duplex-Index
        orl      a,vfoH ; wieder zusammenfgen
        mov      vfoH,a
        sjmp     chScn5

ScBank: ; Scannen in der aktuellen Speicherbank
        inc      memNr
        mov      a,memNr
        cjne     a,#10,chScn1
        mov      memNr,#1
chScn1:
        call     loadMemT
chScn5: call     aktuQRG
        ret


;**********************************************************************
;
;   16-Bit-Vergleich
;
vgl16: setb     btEqual ; vorerst annehmen, da gleich
       clr      c
       subb     a,dpl
       jz       vgl16a
       clr      btEqual ; ungleich
vgl16a:
       mov      a,b
       subb     a,dph
       jz       vgl16b
       clr      btEqual ; ungleich
vgl16b:
       ; wenn hier carry gesetzt ist, dann war berlauf bei der
       ; Subtraktion, also war DPTR>B##A
       ret

;**********************************************************************
;
;	Addiere VFO
;
;	Addiert den Wert von B##A zum vfo.
;
addVFO:
	add	a,vfoL
	mov	vfoL,a
	mov	a,b
	addc	a,vfoH
	mov	vfoH,a
	ret


;**********************************************************************
;
; NextMenu
;
; Schaltet auf den nchsten Einstellwert im Men
;
NextMenu:
        mov     keycount,#0 ; Tastenzhler und Zeichenposition fr
        mov     charPos,#0 ;  Nameneingabe prophylaktisch =0 setzen
	inc	menuPnkt
	mov	a,menuPnkt
        cjne    a,#12,nxm_3
        ; MemName nicht im VFO-Modus
        mov     a,memNr
        jnz     nxm_3
        inc     menuPnkt
nxm_3:
        mov     a,menuPnkt
	cjne	a,#13,nxm_1
	; 13 ist kein gltiger Menpunkt mehr, also auf 1 gehen:
	mov	menuPnkt,#1
nxm_1:
	mov	a,menuPnkt
	cjne	a,#7,nxm_2
	; 7 gewhlt
	mov	a,memNr
	jz	nxm_2	; vfo ist aktiv -> ok
	; vfo nicht aktiv, also existiert Shift-Men nicht,
	; also 8 whlen
	mov	menuPnkt,#8
nxm_2:
	call	MenuDisp	
idle_4:
	ajmp idle

;**********************************************************************
;
; MenuUp
;
; Aktion bei Drcken der Pfeil-Rechts-Taste
; (erhht z.B. den aktuellen Men-Einstellwert)
;
MenuUp:
        setb    btRight
	mov	a,menuPnkt
	cjne	a,#0,mUp_no0
	; kein Menpunkt aktiv -> ersten whlen
	inc	a
	inc	menuPnkt
mUp_no0:
	cjne	a,#1,mUp_no1
; 1
	; Volume up
	; -----------------
        mov     a,volume
        cjne    a,#8,mUp1a ; hchste Stufe erreicht?
        sjmp    mUp_all ; ja
mUp1a:  ; nein
	inc	volume
	anl	volume,#0fh
	call	btSetup	; Lautstrke sofort einstellen
	sjmp	mUp_all
mUp_no1:
	cjne	a,#2,mUp_no2
; 2
	; Squelch up
	; -----------------
	mov	a,squelch
	add	a,#2
	anl	a,#07eh ; nur bis 128, nur gerade Werte
	mov	squelch,a
	sjmp	mUp_all

mUp_no2:
	cjne	a,#3,mUp_no3
; 3
	; Tune-Step up
	; -----------------
	mov	a,tuneStep
	rl	a
	mov	tuneStep,a
	sjmp	mUp_all
mUp_no3:
	cjne	a,#4,mUp_no4
; 4
	; Ok fr WriteMem
	; -----------------
	; VFO in Mem(n)-EEPROM schreiben

	mov	memNr,merkMem	; aktiver = gespeicherter Memory
        call    calcBase ; Basisadresse des Speicherkanals berechnen (im akku)
	mov	w_adr,a	; Das ist die Adresse im EEPROM
	mov	a,vfoL
	call	eep_rwr ; random write
	inc	w_adr
	mov	a,vfoH
	call	eep_rwr ; random write
        ; Der Memory-Name bleibt unverndert, bis ein neuer
        ; eingegeben wird.
	;
	mov	memTH,vfoH
	mov	memTL,vfoL
	call	aktuQRG
        mov     menuPnkt,#0
	ajmp	idle
mUp_no4:
	cjne	a,#5,mUp_no5
; 5
	; Taste nicht aktiv bei Betriebsspannung
	ajmp	idle
mUp_no5:
	cjne	a,#6,mUp_no6
; 6
	; --------------------------
	; Erhhen TX-Power (0 bis 3)
	; --------------------------
	mov	a,txpwr
	inc	a
	anl	a,#3
	mov	txPwr,a
	call	aktuPwr
mUp_all:
	call	MenuDisp
	sjmp	idle_4

mUp_no6:
	cjne	a,#7,mUp_no7

; 7
;---------------------------------------------------------------------------------------------------------------------- ----------------------
;	 Relais-Shift
;----------------------------------------------------------------------------------------------------------------------- ----------------------
		mov		a,vfoH
		anl		a,#0f0h		; nur Shift-Index
		add		a,#10h
		cjne		a,#090h,mUp_7a	; Shift index 0 bis 8 ist ok
		clr		a
mUp_7a:
		mov		b,a		; shift-index merken
		mov		a,vfoH
		anl		a,#0fh		; teiler-high-bits
		orl		a,b		; mit shift-index zusammenbauen
		mov		vfoH,a		; und zurckschreiben
mUp_7b:	call		MenuDisp
		ajmp		idle

mUp_no7:
	cjne	a,#8,mUp_no8
; 8
	; ----------------------
	; Light
	; ----------------------
        mov    a,memPage ; Bit 7 ist Licht-Modus
        xrl    a,#80h
        mov    memPage,a
        sjmp   mUp_7b

mUp_no8:
	cjne	a,#9,mUp_no9
; 9
	; ----------------------
	; Mem -> VFO
	; ----------------------
	mov	memNr,#0	; VFO aktivieren
	mov	vfoH,memTH
	mov	vfoL,memTL
	call	aktuQRG
        mov     menuPnkt,#0
	ajmp	idle
mUp_no9:
; 10 und 11: Taste nicht aktiv

        cjne    a,#12,mUp_no12
; 12
        ;----------------
        ; MemText-Eingabe -> zum nchsten Zeichen gehen
        ;----------------
        mov     a,charPos
        inc     a
        anl     a,#3
        mov     charPos,a
        mov     keyCount,#0
mUp_no12:
	sjmp    mUp_all

;**********************************************************************
;
; MenuDown
;
; Aktion bei Drcken der Pfeil-Links-Taste
; (verringert z.B. den aktuellen Men-Einstellwert)
;
MenuDown:
        setb    btLeft
	mov	a,menuPnkt
	cjne	a,#0,mDn_no0
	; kein Menpunkt aktiv -> ersten whlen
	inc	a
	inc	menuPnkt
mDn_no0:
	cjne	a,#1,mDn_no1
; 1
	; -----------------
	; Volume dn
	; -----------------
        mov     a,volume
        jz      mUp_all ; wenn 0, dann nichts ndern
	dec	volume
	call	btSetup	; Lautstrke sofort einstellen
	sjmp	mUp_all
mDn_no1:
	cjne	a,#2,mDn_no2
; 2
	; -----------------
	; Squelch dn
	; -----------------
	mov	a,squelch
	add	a,#0feh ; -2
	anl	a,#07eh ; nur bis 128, nur gerade Werte
	mov	squelch,a
	sjmp	mUp_all

mDn_no2:
	cjne	a,#3,mDn_no3
; 3
	; -----------------
	; Tune-Step dn
	; -----------------
	mov	tuneStep,#1 ; kleinste Schrittweite
	sjmp	mUp_all
mDn_no3:
	cjne	a,#4,mDn_no4
; 4
	; im WriteMem-Men ist linke Taste wirkungslos
	sjmp	mUp_all
mDn_no4:
	cjne	a,#5,mDn_no5
; 5
	; Freq-Eingabe -> wirkungslos
	ajmp	mUp_all

mDn_no5:
	cjne	a,#6,mDn_no6
; 6
	; verringern TX-Power
	mov	a,txPwr
	dec	a
	anl	a,#03h
	mov	txPwr,a
	call	aktuPwr
	ajmp	mUp_all
mDn_no6:
        cjne    a,#12,mDn_no12
        ; ok fr Nameneingabe
        call    calcbase
        ; a enthlt Basisadresse
        inc     a
        mov     w_adr,a
        mov     r0,#memChr0
        mov     b,#4
mDn12a:
        inc     w_adr
        mov     a,@r0
        call    eep_rwr
        inc     r0
        djnz    b,mDn12a   ; 4 Zeichen in eeprom kopieren
        mov     menuPnkt,#0
        call    aktuQRG
        ajmp    idle
mDn_no12:
; 7 bis 11: Taste wirkungslos
	ajmp	mUp_all

;**********************************************************************
;
; BtSetup  (mit 9a2 wieder aus 9a bernommen)
;
; Bedienteil-Setup
;   setzt Bedienteil-Einstellungen:
;	* Licht ein/aus
;	* Mikrofon ein/aus
;	* Hrmuschel ein
;	* Beim Senden Raum-Mikro, beim Empfangen Hrer-NF (ex Mund-Mikro)
;	* Hrer-Lautstrke
;
BtSetup:
	mov	sbuffer+0,#000h
	mov	sbuffer+1,#01ah
	mov	sbuffer+2,#006h
	mov	sbuffer+3,#007h
	mov	a,volume
        jz      bts_1 ; volume 0 -> stufe 0
        ; volume 1 bis 8 -> stufe 0 bis 7
        dec     a
bts_1:
	swap	a	; 3 Lautstrke-Bits in Bit 4 bis 6
	; orl	a,#002h	; Hrmuschel ein
        mov     c,btTone
        cpl     c
        mov     acc.2,c ; Mic aus bei Rufton
	mov	c,btTxRq
	mov	acc.3,c	; Raum-Mic beim TX, Hrer-NF bei RX
        cpl     c
        mov     acc.1,c ; Hrmuschel beim Senden aus, sonst ein
	mov	c,btLiSol
	mov	acc.0,c
	mov	btLiIst,c
	mov	sbuffer+4,A
	call	BusRQ
	call	sendStc
	call	wait50
	ret


;**********************************************************************
;
; Aktualisieren des Sendeleistungs-Sollwertes
;
aktuPwr:
	mov	a,txPwr ; 0 bis 3
	mov	c,acc.0
	mov	PwrAdj0,c
	mov	c,acc.1
	mov	PwrAdj1,c
        jz      akPw0
        setb    PwrAdjL
        ret
akPw0:  clr     PwrAdjL ; very-low bei Stufe 0
	ret


;**********************************************************************
;
; Spannungs-Alarm
;
uAlarm:
       call     vorbTon
       mov      sbuffer+6,#3 ; Tonlnge
       mov      sbuffer+8,#5 ; Tonanzahl
       call     busRq
       call     sendStc
       call     wait50
       mov      DPTR,#txtUAlrm
       call     eintrTxt
       call     busRq
       call     sendStc
       call     wait50
       ret

;**********************************************************************
;
;  Aktualisieren Frequenz
;  (zuerst in PLL, dann in Anzeige)
;
;	IN: memNr  0, (0..3)*10+(1..9), wobei 0 der VFO ist
;	    btTxRq
;	    btInv
;
aktuQRG:
	mov	A,memNr
	jnz	MemQRGa
	; Der VFO ist ausgewhlt.
	; Frequenzteiler (incl. Zusatz-Bits) aus VFO-Speicher holen
	mov	frTeiL,vfoL
	mov	frTeiH,vfoH
	sjmp	akQ003
MemQRGa:
	; Ein Speicherkanal ist ausgewhlt.
	; Frequenzteiler (incl. Zusatz-Bits) aus MemT-Speicher holen:
	mov	frTeiL,memTL
	mov	frTeiH,memTH
akQ003:
	; hier Bits 12..15 separieren:
	mov	a,frTeiH
	anl	a,#0f0h
	swap	a
	; 0..15, Shift-Index
	mov	tmp,a
	mov	a,frTeiH
	anl	A,#0fh
	mov	frTeiH,A
	; 12 Bit Wert steht in frTeiH##frTeiL
	; hier 30000 = 0x7530 addieren
	mov	a,frTeiL
	add	a,#30h
	mov	frTeiL,a
	mov	a,frTeiH
	addc	a,#75h
	mov	frTeiH,a
	; Teiler fr Empfangsfall steht in frTeiH##frTeiL

	jnb	btTxRq,akQ004a
	; beim Senden: 10000kHz/12k5 == 0320h addieren:
	mov	A,frTeiL
	add	A,#020h
	mov	frTeiL,A
	mov	A,frTeiH
	addc	A,#03h
	mov	frTeiH,A
        ; beim Senden auch Scan abschalten:
        call    scanAbort
akQ004a:
	mov	C,btTxRq
	mov	B.0,C
	mov	C,btInv
	mov	acc.0,C
	xrl	a,B
	; acc.0=1, wenn Senden xor Invers
	jnb	acc.0,akQ004b
	; bei (Senden xor invers): Ablage verrechnen
	mov	DPTR,#dupTable
	mov	a,tmp ; Tabellenindex
	rl	a	; mal zwei
	add	a,DPL
	mov	DPL,a
	mov	a,DPH
	addc	a,#0
	mov	DPH,a
	; DPTR steht auf 2-Byte-Eintrag der Duplex-Tabelle
	clr	a
	movc	a,@a+DPTR
	add	a,frTeiL
	mov	frTeiL,a
	inc	DPTR
	clr	a
	movc	a,@a+DPTR
	addc	a,frTeiH
	mov	frTeiH,A
akQ004b:
	jb	btTxRq,akQ004c
	 ; beim Empfang: zuerst Sender aus
	setb	TxEnab
        clr     btOffBnd ; beim Empfang gibts keine Bandgrenzen
akQ004c:

	;  Freq-Teiler der PLL zusammenbasteln
	mov	I2CAdr,#0c6h	; slave-Adresse
	mov	I2CCnt,#4	; Anzahl
	mov	ibuffer+0,#00eh	; 1.Byte -> konstant

	mov	A,frTeiL
	swap	A
	anl	A,#03h
	mov	ibuffer+1,A	; 2.Byte

	mov	A,frTeiL
	swap	A
	anl	A,#0f0h
	mov	B,A
	mov	A,frTeiH
	rl	A
	rl	A
	anl	A,#03h
	orl	A,B
	mov	ibuffer+2,A	; 3.Byte

	mov	B,frTeiL
	mov	A,frTeiH
	rl	A
	rl	A
	mov	C,B.7
	mov	acc.1,C
	mov	C,B.6
	mov	acc.0,C
	mov	ibuffer+3,A	; 4.Byte

	call	I2C_wr	; PLL einstellen

	call	vorbText ; Display-Puffer vorbereiten, alles Leerzeichen 

	mov	A,memNr
	jnz	MemQRGb
	; Der VFO ist ausgewhlt.
	mov	sbuffer+6,#'V'
	mov	sbuffer+7,#'F'
	mov	sbuffer+8,#'O'
	sjmp	akQ010
MemQRGb:
	; Ein Speicherkanal ist ausgewhlt.
	; String "Mmn" und Speichername fr's Display
	mov	sbuffer+4,#'M'
	call	hexdig
	mov	sbuffer+6,a
	mov	a,memPage
	swap	a
        anl     a,#03h ; Licht-Modus weglassen
	call	hexdig
	mov	sbuffer+5,a
        mov     sbuffer+8,memChr0
        mov     sbuffer+9,memChr1
        mov     sbuffer+10,memChr2
        mov     sbuffer+11,memChr3
akQ010:
	; aus Teiler reale Frequenz berechnen   frq = (frTei * 25) div 2
	mov	A,frTeiL
	mov	B,#25
	mul	ab
	mov	frqL,A
	mov	frqM,B
	mov	A,frTeiH
	mov	B,#25
	mul	ab
	mov	frqH,B
	add	A,frqM
	mov	frqM,A
	mov	A,frqH
	addc	A,#0
	mov	frqH,A
	; mal 25 fertig
	mov	A,frqH
	clr	c
	rrc	A
	mov	frqH,A
	mov	A,frqM
	rrc	A
	mov	frqM,A
	mov	A,frqL
	rrc	A
	mov	frqL,A
	; div 2 fertig

	; bei RX ZF=45000=afc8h, bei TX  TXOsz=35000=88b8h addieren:
	; und zwar so: immer 35000=88b8h addieren, und dann bei
	; Bedarf (also bei RX) noch 10000=2710h dazu

	mov	A,frqL
	add	A,#0b8h
	mov	frqL,A
	mov	A,frqM
	addc	A,#088h
	mov	frqM,A
	mov	A,frqH
	addc	A,#0
	mov	frqH,A

	jb	btTxRq,akQ006

	mov	A,frqL
	add	A,#010h
	mov	frqL,A
	mov	A,frqM
	addc	A,#027h
	mov	frqM,A
	mov	A,frqH
	addc	A,#0
	mov	frqH,A
akQ006:
	; ZF addiert

	call	bin2asc
	
	mov	a,tmp ; Duplex-Index
	jz	akQ007
	; Duplex-Anzeige
	mov	sbuffer+19,#'d'
akQ007:
	jnb	btTxRq,akQ008

;**************************************************************************
;	 im Sendemodus Bandgrenzen berprfen
;	430 MHz 31600 0x7b70
;	440 MHz 32400 0x7e90
;**************************************************************************

		mov		a,frTeiH
		cjne		a,#07bh,akQ007a
		mov		a,frTeiL
		cjne		a,#070h,akQ007a
		clr		c 		; gleich 430 ist noch ok
akQ007a:	jc		offBand
						; untere Grenze war ok, jetzt obere prfen
		mov		a,frTeiH
		cjne		a,#07eh,akQ007b
		mov		a,frTeiL
		cjne		a,#090h,akQ007b
		setb		c		; gleich 440 ist noch gut
akQ007b:	jnc		offBand

		clr		btOffBnd
akQ008:						; Zahlenstring einkopieren
		mov		sbuffer+12,abuffer+0
		mov		sbuffer+13,abuffer+1
		mov		sbuffer+14,abuffer+2
		mov		sbuffer+15,#'.'
		mov		sbuffer+16,abuffer+3
		mov		sbuffer+17,abuffer+4
		mov		sbuffer+18,abuffer+5
		sjmp		akQ008a
offBand:
		setb		btOffBnd
		mov		sbuffer+14,#'o'
		mov		sbuffer+15,#'f'
		mov		sbuffer+16,#'f'
akQ008a:					; abschicken
		call		busRQ
		call		sendStc		; abschicken

; Das schicken des neuen Displayinhaltes hat etwa 25 ms gedauert,
; jetzt kann der Sender eingeschaltet werden (bei TX).
; Bei RX wurde er schon vorher ausgeschaltet.

	jnb	btTxRq,akQ009
	jb	btOffBnd,akQ009 ; nicht senden auerhalb vom Band
	clr	txEnab ; Sender ein
akQ009:
	call	wait50 ; Verschnaufpause fr's Bedienteil

	mov	C,btTxOld ; Sendezustand beim vorherigen Aufruf
	mov	acc.0,C
	mov	C,btTxRq ; Aktueller Sendezustand
	mov	b.0,C
	xrl	a,b
	jnb	acc.0,akQ011 ; keine nderung
	; Zustand hat sich gendert
	cpl	btTxOld	; neuen Zustand merken
	call	btSetup ; NF-Signalweg im Bedienteil entsprechend RX/TX setzen
			; (ist nicht so zeitkritisch, packet audio luft nicht
			; ber das Bedienteil)
akQ011:
	ret


;***********************************************************************
;
;	Load Memory-Channel Teiler
;
;	Ld den PLL-Teilerfaktor des aktuellen Speicherkanals
;	(inklusive Duplex-Bits) sowie den Text dazu aus dem EEPROM
;
;       Die Basisadresse des Memorykanals berechnet sich zu
;       Basis=6*(Bank*9+memNr-1)
;       Auf der Adresse stehen dann
;         +0: Low-Byte Teiler
;         +1: High-Byte Teiler mit Duplex-Bits
;         +2: 1.Zeichen
;         +3: 2.Zeichen
;         +4: 3.Zeichen
;         +5: 4.Zeichen
;
loadMemT:
        call    calcBase
        ; im akku steht jetzt die Basisadresse
	mov	w_adr,a ; Quelladresse im EEPROM
        mov     r0,#memTL ; Zieladresse
        mov     b,#6 ; Anzahl Bytes
ldMmT1:
	call	eep_rr ; lesen
	mov	@r0,ibuffer+0  ; abspeichern
	inc	w_adr
        inc     r0
        djnz    b,ldMmT1 ; nchstes Byte
	ret


;***********************************************************************
;
;	Calculate Base Address
;
;	Berechnet die EEPROM-Basisadresse des aktuellen Speicherkanals
;
;       Die Basisadresse berechnet sich zu
;         Basis=6*(Bank*9+memNr-1)
;
;      IN: memPage, memNr
;      OUT: a
;      VR: b
;
calcBase:
        mov     a,memPage ; Bits 4 und 5 sind Speicherbanknr.
        anl     a,#030h ; Lichtmodus Bit7 ausblenden
        rr      a
        mov     b,a
        rr      a
        rr      a
        rr      a
        add     a,b ; 1*Bank+8*Bank=9*Bank
        add     a,memNr ; + MemNr
        add     a,#0ffh ; -1
        mov     b,#6
        mul     ab
        ; im akku steht jetzt die Basisadresse
        ret

;***********************************************************************
;
;	Men-Display
;
;	zeigt einen Men-Einstellwert an
;

MenuDisp:	mov	MenuCDN,#25		; 25*200ms = 5 Sekunden

; "Frequenz" auf jeweiligen Wert stellen, um die Konvertierungs-
; routine nach pBCD nutzen zu knnen. Das strt nicht, da die
; frq ohnehin vor jeder echten Frequenzausgabe neu berechnet
; wird.

		clr	a
		mov	frqM,a			; obere 2 Bytes auf
		mov	frqH,a			; Null setzen
		mov	A,menuPnkt		; Nr. des Menpunktes
		cjne	A,#1,diM_no1

; ---------------------------------------------------------------------------------------------------------------------------
; 1	 Volume-Anzeige
; -------------------------------------------------------------------------------------------------------------------------

		mov	DPTR,#txtVolum
		call	eintrTxt
		mov	frqL,volume		; 0 bis 8
		sjmp	diM_zahl
diM_no1:	cjne	A,#2,diM_no2

; ---------------------------------------------------------------------------------------------------------------------------
; 2	 Squelch-Anzeige
; --------------------------------------------------------------------------------------------------------------------------

		mov	DPTR,#txtSquel
		call	eintrTxt
		mov	frqL,squelch
		sjmp	diM_zahl

diM_no2:	cjne	A,#3,diM_no3

; -------------------------------------------------------------------------------------------------------------------------
; 3	 Tuning-Step-Anzeige
; -------------------------------------------------------------------------------------------------------------------------

		mov	DPTR,#txtTnStp
		call	eintrTxt
		mov	a,tuneStep
		mov	b,#25
		mul	ab
		mov	frqL,a
		mov	a,b
		clr	c
		rrc	a
		mov	frqM,a
		mov	a,frqL
		rrc	a
		mov	frqL,a
		sjmp	diM_zahl

diM_no3:	cjne	a,#4,diM_no4

;------------------------------------------------------------------------------------------------------------------------
; 4

                ; in Vorbereitung von Menpunkt 5 (Frequenzeingabe) Status einstellen

	        mov     frInStat,#0 ; war in 9aa auskommentiert, dadurch
                                    ; Bug bei Auswahl der Frequenzeingabe
                                    ; ber "*"-Taste
; ----------------------------------------------------------------------------------------------------------------------
;	VFO_to_MEM
; ----------------------------------------------------------------------------------------------------------------------

		mov	DPTR,#txtMemWr

diM_4a:		call	eintrTxt
		mov	sbuffer+18,#'O'
		mov	sbuffer+19,#'k'
		sjmp	diM_send

diM_zahl:	call	bin2asc			; in ASCII konvertieren

diM_cpAS:	mov	sbuffer+12,abuffer+2	; ASCII in Sendpuffer einkopieren
		mov	sbuffer+13,abuffer+3
		mov	sbuffer+14,abuffer+4
		mov	sbuffer+15,abuffer+5

diM_send:	call	busRQ			; und abschicken	
		call	sendStc
		ret	

diM_no4:	cjne	a,#5,diM_no5

; ----------------------------------------------------------------------------------------------------------------
; 5	 Frequenzeingabe
; ----------------------------------------------------------------------------------------------------------------

		mov	DPTR,#txtFreq
		call	eintrTxt
		sjmp	diM_send

diM_no5:	cjne	a,#6,diM_no6

; -----------------------------------------------------------------------------------------------------------------
; 6	 Tx-Power(Soll)-Einstellung
; -----------------------------------------------------------------------------------------------------------------
		mov	DPTR,#txtTxPwr
		call	eintrTxt
		mov	a,txpwr
		add	a,#1			; aus 0 bis 3 mach 1 bis 4
		mov	frqL,a
		sjmp	diM_zahl

diM_no6:	cjne	a,#7,diM_no7

;-----------------------------------------------------------------------------------------------------------------
; 7	 Relais-Shift-Einstellung
;-----------------------------------------------------------------------------------------------------------------
		mov	DPTR,#txtShift
		call	eintrTxt
		mov	a,vfoH

		swap	a
		anl	a,#0Fh                  ; Duplex-Index 0..15
		mov	b,#06h	                ; 6 Bytes pro Eintrag
		mul	ab

		mov	DPTR,#txtDup
		add	a,dpl
		mov	dpl,a
		mov	a,dph
		addc	a,#0
		mov	dph,a
		clr	a
		movc	a,@a+DPTR
		mov	sbuffer+12,a
		inc	DPTR
		clr	a
		movc	a,@a+DPTR
		mov	sbuffer+13,a
		inc	DPTR
		clr	a
		movc	a,@a+DPTR
		mov	sbuffer+14,a
		inc	DPTR
		clr	a
		movc	a,@a+DPTR
		mov	sbuffer+15,a
		inc	DPTR
		clr	a			;**************  neu 6 Stellige Anzeige bei der Relaisablage **********
		movc	a,@a+DPTR
		mov	sbuffer+16,a
		inc	DPTR
		clr	a
		movc	a,@a+DPTR
		mov	sbuffer+17,a
		sjmp	diM_send

diM_no7:	cjne	a,#8,diM_no8

; ------------------------------------------------------------------------------------------------------------------------------
; 8	 Licht-Modus
; ------------------------------------------------------------------------------------------------------------------------------

		mov	DPTR,#txtLicht
		call	eintrTxt
		mov	a,memPage		; Bit 7 ist Licht-Modus
		anl	a,#80h
		jz	diM_8a
		mov	sbuffer+12,#'n'
		mov	sbuffer+13,#'o'
		mov	sbuffer+14,#'r'
		mov	sbuffer+15,#'m'

diM_8a:		sjmp	diM_send

diM_no8:	cjne	a,#9,diM_no9

; -----------------------------------------------------------------------------------------------------------------------------
; 9	 Memory -> VFO
; -----------------------------------------------------------------------------------------------------------------------------
		mov	DPTR,#txtMemVF
		ljmp	diM_4a

diM_no9:	cjne	a,#10,diM_no10

; ----------------------------------------------------------------------------------------------------------------------------
; 10	 ADC-Anzeige
; ----------------------------------------------------------------------------------------------------------------------------

		call	vorbText
						; ADC 2 ist Spannung ber Teiler 22k 10k
		mov	a,adc2
		mov	b,#161
		mul	ab
		mov	frqM,#0
		mov	frqL,b			; in B steht Spannung in Zehntel Volt
		call	bin2asc			; in ASCII konvertieren
		mov	sbuffer+4,abuffer+3
		mov	sbuffer+5,abuffer+4
		mov	sbuffer+6,#'.'
		mov	sbuffer+7,abuffer+5
		mov	sbuffer+9,#'V'
						; Spannung als Klartext fertig
						; nun Temperatur eintragen (ADC 1)
						; 0=20C, 255=71C, fast linear
		mov	a,adc1
		cjne	a,#4,diM10c
diM10c:		jnc	diM10a
						; Temperaturanzeige nahe am unteren Anschlag (bei ca.21 Grad)
		mov	sbuffer+13,#'C'
		mov	sbuffer+14,#'o'
		mov	sbuffer+15,#'o'
		mov	sbuffer+16,#'l'
		sjmp	diM10b

diM10a:		mov	b,#2
		mul	ab
						; 8 bis 510 in B##A
		add	a,#200			; 20C/0.1C
		mov	frqL,a
		mov	a,b
		addc	a,#0
		mov	frqM,a
		call	bin2asc
		mov	sbuffer+12,abuffer+3
		mov	sbuffer+13,abuffer+4
		mov	sbuffer+14,#'.'
		mov	sbuffer+15,abuffer+5
		mov	sbuffer+17,#'C'

diM10b:						; Temperatur als Klartext fertig

diM_snd_:	ljmp	diM_send

diM_no10:	cjne	a,#11,diM_no11

; ---------------------------------------------------------------------------------------------------------------------------
; 11	 Copyright und Datum
; ---------------------------------------------------------------------------------------------------------------------------

		mov	DPTR,#txtCopyr
		call	eintrTxt
		sjmp	diM_snd_

diM_no11:

; ----------------------------------------------------------------------------------------------------------------------------
; 12	 MemText-Eingabe
; ----------------------------------------------------------------------------------------------------------------------------

		mov	DPTR,#txtMemTxt
		call	eintrTxt
		mov	sbuffer+12,#'o'
		mov	sbuffer+13,#'k'
		mov	sbuffer+16,memChr0
		mov	sbuffer+17,memChr1
		mov	sbuffer+18,memChr2
		mov	sbuffer+19,memChr3
		sjmp	diM_snd_


;********************************************************************
; Vorbereiten des SCI-Sendepuffers auf Textbertragung und
; Eintragen eines Textes
;
; in: DPTR zeigt auf nullterminierten string
;*********************************************************************

eintrTxt:		call	vorbText
		mov	r0,#sbuffer+4
eintrT2:		clr	a
		movc	a,@a+DPTR		; Zeichen aus Code-ROM
		jz	eintrT3			; Ende-Kennzeichen?
		mov	@r0,a			; eintragen
		inc	DPTR
		inc	r0
		sjmp	eintrT2
eintrT3:	ret

;********************************************************************
;	Vorbereiten des SCI-Sendepuffers auf Textbertragung (16Zeichen)
;	zum Bedienteil
;********************************************************************

vorbText:	mov	sbuffer+0,#000h
		mov	sbuffer+1,#01ah
		mov	sbuffer+2,#015h
		mov	sbuffer+3,#002h
		mov	r0,#sbuffer+4		; index im RAM
		mov	r2,#16			; anzahl
		mov	A,#' '			; zeichen-voreinstellung
vorT_1:		mov	@r0,A
		inc	r0
		djnz	r2,vorT_1
		ret

;********************************************************************
;	Vorbereiten des SCI-Sendepuffers auf Tonausgabe
;********************************************************************

vorbTon:	mov	sbuffer+0,#000h
		mov	sbuffer+1,#01ah
		mov	sbuffer+2,#00bh
		mov	sbuffer+3,#008h
		mov	sbuffer+4,#040h
		mov	sbuffer+5,#04fh
		mov	sbuffer+6,#007h
		mov	sbuffer+7,#003h
		mov	sbuffer+8,#002h
		mov	sbuffer+9,#013h
		ret

;************************************************************************
; Konvertierung binr zu ASCII (dezimal)
; Quelle: frq_
; Ziel: abuffer
;*************************************************************************

bin2asc:	call	bin2bcd
		call	bcd2asc
		ret

;**************************************************************************
; Konvertierung packed-BCD (3Byte) in ASCII (6 Byte)
;
; Quelle: pbcdL...pbcdH
; Ziel: abuffer (ASCII-Buffer)
;
; Geht auch fr hex-Zahlen, dann 3-Byte-Binrzahl in pbcdL...pbcdH
;**************************************************************************

bcd2asc:	mov	a,pbcdH
		swap	a
		call	hexdig
		mov	abuffer+0,a
		mov	a,pbcdH
		call	hexdig
		mov	abuffer+1,a
	
		mov	a,pbcdM
		swap	a
		call	hexdig
		mov	abuffer+2,a
		mov	a,pbcdM
		call	hexdig
		mov	abuffer+3,a

		mov	a,pbcdL
		swap	a
		call	hexdig
		mov	abuffer+4,a
		mov	a,pbcdL
		call	hexdig
		mov	abuffer+5,a
		ret

;**************************************************************************
; Konvertierung Binrzahl (3Byte) in packed-BCD (3Byte) 
;
; Quelle: frqL...frqH (wird gerettet)
; Ziel: pbcdL...pbcdH
;**************************************************************************

bin2bcd:	push	frqL
		push	frqM
		push	frqH
		clr	a
		mov	pbcdL,a
		mov	pbcdM,a
		mov	pbcdH,a

		mov	r0,#24			; 24 Bit Dualzahl

b2pblp:		mov	r1,#pbcdL		; packed-BCD verdoppeln:
		clr	a

doppbcd:	mov	C,acc.0 
		mov	a,@r1
		addc	a,@r1
		da	a
		mov	@r1,a
		mov	acc.0,C
		inc	r1
		cjne	r1,#pbcdH+1,doppbcd

						; ein Bit aus Binrzahl herausschieben:
		mov	r1,#frqL

shlbi:		mov	 C,acc.0
		mov	a,@r1
		rlc	a
		mov	@r1,a
		mov	acc.0,C
		inc	r1
		cjne	r1,#frqH+1,shlbi

						; ACC.0 enthlt herausgeschobenes Bit
		anl	a,#1 ; nur dieses Bit interessiert
						; ein Bit zur packed-BCD addieren:
		add	a,pbcdL
		da	a
		mov	pbcdL,a
		mov	acc.0,C
		mov	r1,#pbcdM

addlp:		mov	C,acc.0
		mov	a,@r1
		addc	a,#0
		da	a
		mov	@r1,a
		mov	acc.0,C
		inc	r1
		cjne	r1,#pbcdH+1,addlp

		djnz	r0,b2pblp
		pop	frqH
		pop	frqM
		pop	frqL
		ret

;*************************************************************************
; hex-digit
; Konvertierung des Low-Nibbles von A in Hex-Ziffer
;
hexdig:		anl	a,#0fh
		;mov	r0,a
		;mov	a,lzsup
		;cjne	a,#1,xxx1			; falls Nullenunterdrckung nicht erlaubt->weiter
						; Nullenunterdrckung erlaubt:
		;mov	a,r0
		;jz	xxxnu			; ist die Ziffer eine Null ?
						; keine Null:
		;mov	lzsup,#0			; Nullenunterdrckung sperren
		;sjmp	xxx1
;xxxnu:						; ist Null:
		;mov	a,#' '
		;sjmp	xxend
;xxx1:		mov	a,r0
		cjne	a,#10,xxx0		; carry setzen, wenn A<10

xxx0:		jc	xxzahl
		add	a,#7			;'A'-'0'-10 ; in ASCII-Buchstaben wandeln

xxzahl:		add	a,#'0'			; in ASCII-Zahl wandeln

xxend:		ret

;############################################################################
;
;  Kommunikationsroutinen
;  SCI-Bus (TTL-RS232)
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ SCI BUS +++++
;
; Bus-Request
; sendet Break-Signal auf SCI-Bus
; IN: -
; OUT: -
; VR: r2, r3
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

busRQ:		clr	LED
		clr	TXD			; Leitung auf 0
						; bis Version 8h vom 19.08.2000 war hier
		;mov	r2,#5			; ca. 2 ms warten
						; jetzt:
						; ca. 3.3 ms warten
		mov	r2,#8
		call	wait
		setb	TXD			; Leitung auf 1
						; ca. 9.4 ms warten
		mov	r2,#23
		call	wait
		setb	LED 
		ret

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ SCI BUS +++++
;
; SendSentence
; sendet einen kompletten Datensatz auf SCI-Bus
; IN: sbuffer=satzinhalt, wobei prfbyte selbst berechnet wird
;  Struktur: 	1. Byte  00h
;		2. Byte  7fh
;		3. Byte  Lnge ber alles = n
;		4.usw. Byte Nutzdaten
;		n. Byte  xor-Prfbyte ber 1 bis (n-1)
; OUT: -
; VR: r0, r2, r3, chksum, tmp
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

sendStc:	clr	LED
		mov	chksum,#0		; Prfsumme=0
		mov	r0,#sbuffer
		inc	r0
		inc	r0
		mov	tmp,@r0			; Satzlnge
		dec	tmp			; ohne Prfsumme
		mov	r0,#sbuffer

sendst1:	mov	A,@r0			; Byte aus Satzspeicher holen
		xrl	chksum,A		; zur Prfsumme verrechnen
		call	sendSer			; und abschicken
		inc	r0
		djnz	tmp,sendst1
		mov	A,chksum
		call	sendSer
		setb	LED
		ret

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ SCI BUS +++++
;
; RX-Byte   holt Byte von SCI-Schnittstelle
; IN: -
; OUT: A
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

rxbyte:		clr	SCON.0			; Bit wieder lschen
		mov	A,SBUF			; Daten abholen
		ret

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ SCI BUS +++++
;
; Send seriell
; schickt ein Byte auf die SCI-Schnittstelle,
; wartet bis es 'raus ist und noch ca. 280 us lnger
; IN: A
; VR: r2=0
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

sendSer:		mov	SBUF,A

sends1:		jnb	SCON.1,sends1		; warten auf TX fertig
		clr	SCON.1			; TX interrupt flag rcksetzen
		mov	r2,#175

sends2:		djnz	r2,sends2		; 2*175 Zyklen * 0.8us/Zyklus = 280 us
		ret

;############################################################################
;
;	I2C - Routinen
;
;********************************************* User ********* I2C BUS *******
;
;   PLL Initialisierung
;*****************************************************************************

pllinit:
        ; 1.: Modus einstellen
		mov	I2CAdr,#0c6h		; slave-Adresse
		mov	I2CCnt,#2		; Anzahl
		mov	ibuffer+0,#00ah
		mov	ibuffer+1,#07eh
		call	I2C_wr
	; 2.: Ref-Teiler einstellen
		mov	I2CAdr,#0c6h		; slave-Adresse
		mov	I2CCnt,#3		; Anzahl
		mov	ibuffer+0,#006h	
		mov	ibuffer+1,#004h		;  12.5 kHz Raster
		mov	ibuffer+2,#0a4h
		call	I2C_wr
	; 3.: Freq-Teiler einstellen
		mov	I2CAdr,#0c6h		; slave-Adresse
		mov	I2CCnt,#4		; Anzahl
		mov	ibuffer+0,#00eh
		mov	ibuffer+1,#001h		; DB0TUD voreinstellen 
		mov	ibuffer+2,#061h
		mov	ibuffer+3,#0ech
		call	I2C_wr
		ret

;********************************************* User ********* I2C BUS *******
;
;   ADC/DAC Initialisierung
;*************************************************************************

addainit:	; Modus und Ausgangsspannung einstellen
		mov	I2CAdr,#090h		; slave-Adresse
		mov	I2CCnt,#2		; Anzahl
		mov	ibuffer+0,#044h		; analog-output-enable, auto increment
		mov	ibuffer+1,#080h		; DA-Wert
		call	I2C_wr
		ret

;********************************************* User ********* I2C BUS *******
;
;   ADC Read
;*************************************************************************

adc_rd:		mov	I2CAdr,#090h	; slave-Adresse
		mov	I2CCnt,#8	; 8 Werte lesen
		call	I2C_rd
		; ibuffer+0 enthlt alten AD-Kanal 3 -> entsorgen
		mov	adc0,ibuffer+1
		mov	adc1,ibuffer+2
		mov	adc2,ibuffer+3
		mov	adc3,ibuffer+4
                ; die brigen 3 auch entsorgen
		ret

;********************************************* User ********* I2C BUS *******
;
;   EEPROM Write All
;*************************************************************************

EEP_WRALL:
; squelch schreiben:
		mov	w_adr,#0f0h
		mov	A,squelch
		call	EEP_RWR
; volume schreiben:
		inc	w_adr ; F1
		mov	A,volume
		call	EEP_RWR
; memNr schreiben:
		inc	w_adr  ; F2
		mov	A,memNr
		add	a,memPage	; (enthlt in Bit 7 Lichtmodus)
		call	EEP_RWR
; txPwr schreiben:
		inc	w_adr   ; F3
		mov	A,txPwr
		call	EEP_RWR
; tuneStep schreiben:
		inc	w_adr   ; F4
		mov	A,tuneStep
		call	EEP_RWR
; Squelch-"Null" schreiben:
		inc	w_adr   ; F5
		mov	A,s0
		call	EEP_RWR
; vfo schreiben:
		inc	w_adr   ; F6
		mov	A,vfoL
		call	EEP_RWR
		inc	w_adr   ; F7
		mov	A,vfoH
		call	EEP_RWR
; KeyLock-Bit schreiben:
		inc	w_adr   ; F8
                clr     a
                mov     c,btKeyLock
		mov	acc.0,c
		call	EEP_RWR

		ret

;********************************************* User ********* I2C BUS *******
;
;   EEPROM Random Write
;
;  IN:	W_ADR = Adresse
;	A = Daten
;  VR: r1, r2, a
;**************************************************************************

EEP_RWR:	mov	I2CAdr,#0a0h		; slave-Adresse
		mov	I2CCnt,#2		; Anzahl
		mov	ibuffer+0,W_ADR
		mov	ibuffer+1,A
		call	I2C_wr
		call	wait50
		ret

;********************************************* User ********* I2C BUS *******
;
;	EEPROM RANDOM READ                                        
;
;	IN:    W_ADR  
;	VERAENDERT:ACC
;
;	OUT:   iBuffer[0], C                                                   
;
;	Liest ein Byte aus dem EEPROM.         
;	Mit W_ADR wird die Adresse des zu lesenden Bytes    
;	bergeben.
;***************************************************************************

EEP_RR: 	mov	I2CAdr,#0a0h		; slave-Adresse
		mov	I2CCnt,#1		; Anzahl
		mov	ibuffer+0,w_adr
		call	I2C_wr
		mov	I2CCnt,#1		; Anzahl
		call	I2C_rd
		ret

;********************************************* User ********* I2C BUS *******
;
;   DTMF Write
;
;  IN:	a = Daten
;  VR: r1, r2, a
;*************************************************************************

DTMF_WR:	mov	I2CAdr,#0aah		; slave-Adresse
		mov	I2CCnt,#1		; Anzahl
		mov	ibuffer+0,a
		setb	btSlowI2C
		call	I2C_wr
		clr	btSlowI2C
		ret

;---------------------------------- High-Level ------------ I2C BUS ---------------------------------------------------
;
;   I2C READ                                        
;   Liest von I2D-Device.         
;   Die gelesenen Bytes liegen in iBUFFER.      
;
;	IN:    I2CAdr, I2CCnt  
;	VERAENDERT: I2CCnt=0, ACC, r1
;
;	OUT:   iBUFFER,C
;--------------------------------------------------------------------------------------------------------------------------------

I2C_RD:         mov	A,I2CAdr		; slave-Adresse
		orl	A,#01h			; read -> R/W=1
		call	START
		call	wrBytI2C		; und senden
		jc	ENDIRD			; Abbruch, wenn kein ACK
		mov	r1,#ibuffer		; erste Zieladresse

IRDLP1:		call	rdBytI2C		; Byte lesen
		mov	@r1,A			; und ablegen
		inc	r1			; Zieladresse weiterstellen
		dec	I2CCnt			; Anzahl verringern
		mov	A,I2CCnt		; Anzahl
		jz	IRDRDY			; =0?
		call	ACK			; sonst acknowledge
		sjmp	IRDLP1			; und nchstes Byte

IRDRDY:	call	NACK			; NACK senden
		clr	C

ENDIRD:	call	STOP			; Stopbedingung senden
		ret

;---------------------------------- High-Level ------------ I2C BUS ----------------------------------------------------------
;
;   I2C WRITE                                        
;   Schreibt zu I2C-Device.         
;                                                                       
;	IN:    I2CAdr, I2CCnt, iBUFFER  
;	VERAENDERT: I2CCnt=0, ACC, r1, r2
;
;	OUT:   C                                                   
;----------------------------------------------------------------------------------------------------------------------------------------

I2C_WR:        	mov	A,I2CAdr		; slave-Adresse
		anl	A,#0feh			; write -> R/W=0
		call	START			; Startbedingung senden
		call	wrBytI2C		; Device Adresse senden
		;jc	ENDIWR		; wenn kein ACK gelesen wurde, beenden
		mov	r1,#ibuffer		; Pointer auf erstes Byte

IWRLP1:	mov	A,@r1			; Byte aus Puffer
		call	wrBytI2C		; senden
		;jc	ENDIWR		; s.o.
		inc	r1			; nchstes Byte
		dec	I2CCnt
		mov	A,I2CCnt
		jnz	IWRLP1

ENDIWR:	call	STOP			;Stopbedingung senden        
		ret

;----------------------------------------------------------- I2C BUS ------
;
;	I2C   Low-Level-Routinen
;
;------------------------------------ Low Level ------------ I2C BUS ------
;
;  read Byte I2C                                                           
;                                                                       
;      IN:                                                              
;      OUT:         acc                                               
;      VERAENDERT:  r2, ACC, C                                       
;                                                                       
;	Liest 8 Bit an SDA ein. Das gelesene                             
;	Byte wird in acc zurueckgegeben                                
;-----------------------------------------------------------------------------------------------------------------------

rdBytI2C:	setb	SDA			;SDA zum Eingang machen
		mov	r2,#08H			;Zhler mit 8 laden

rdBytLp:       	call	CLOCK			;Bit einlesen
		rlc	A			;Bit im Carry von rechts in acc schieben
		djnz	r2,rdBytLp		;Schleifenzaehler um eins reduzieren und
                                				;weiterlesen, falls noch keine 8 Bit
                                				;gelesen wurden
		ret

;------------------------------------ Low Level ------------ I2C BUS ------
;
;  write Byte I2C                                                          
;                                                                       
;      IN:          ACC                                                 
;      OUT:         C                                                    
;      VERAENDERT:  r2                                      
;                                                                       
;   Schreibt 8 Bit an I2C-Device.                                       
;   Das zu schreibende Byte wird im Akku bergeben                     
;----------------------------------------------------------------------------------------------------------------------

wrBytI2C:	mov	r2,#08H			;Zhler mit 8 laden

wrByLp:		rlc     A				;MSB in Carry laden
		mov     SDA,C			;und ueber SDA ausgeben
		call    CLOCK			;und Bit auf Bus "clocken"
		djnz    r2,wrByLp			;weiterschreiben, falls noch nicht alle 
						;8 Bits gesendet wurden
		setb    SDA			;SDA auf High, damit ACK des Devices
				                                ;gelesen werden kann
		call	CLOCK			; ACK in's carry lesen	
		ret

;------------------------------------ Low Level ------------ I2C BUS ------
;
;  void-Daten zur Initialisierung auf I2C                                                          
;                                                                       
;      IN:          -
;      OUT:         -                                                    
;      VERAENDERT:  r2,A                                      
;                                                                       
;--------------------------------------------------------------------------------------------------------------------------

voidI2C:		call	STOP
		call	START
		mov	r2,#40			;Zaehler mit 40 laden (hauptsache viel :-)

voidLp:		clr	SDA			;und ueber SDA = 0 ausgeben
		call	CLOCK			;und Bit auf Bus "clocken"
		djnz	r2,voidLp		;weiterschreiben, falls noch nicht alle 
						; Bits gesendet wurden
		call	STOP
		ret

;------------------------------------ Low Level ------------ I2C BUS ------
;
; Start Bedingung senden
;---------------------------------------------------------------------------------------------------------------

START:		call	waitus
		setb	SDA
		setb	SCL
		call	waitus
		clr	SDA			;eigentliche Startbedingung
		call	waitus
		clr	SCL
		ret                     

;------------------------------------ Low Level ------------ I2C BUS ------
;
; Stop Bedingung senden
;-----------------------------------------------------------------------------------------------------------------

STOP:		call	waitus
		clr	SDA
		call	waitus
		setb	SCL
		call	waitus                
		setb	SDA			; eigentliche Stopbedingung
		ret

;------------------------------------ Low Level ------------ I2C BUS -----------------------------------------
; Clock-Impuls senden
; und Zustand abfragen  
;                                                                        
;      IN:                                                               
;      OUT:         C                                                    
;                                                                        
;      Erzeugt einen pos. Clockimpuls an SCL  ( __/"""\__ )  und         
;      speichert den Zustand von SDA im Carry-Flag.                      
;      Kann zum empfangen und senden verwendet werden                    
;---------------------------------------------------------------------------------------------------------------------

CLOCK:		call	waitus
		setb	SCL			;SCL auf High
		call	waitus
		mov	C,SDA			;Zustand von SDA, also gesendetes Bit in
		clr	SCL			;Carry speichern, und SCL wieder auf Low.
		ret

;------------------------------------ Low Level ------------ I2C BUS -----------------------------------------
; ACKNOWLEDGE                                                      
;                                                                       
;      IN:                                                              
;      OUT:                                                             
;      VERAENDERT:  C                                                   
;                                                                       
;      Sendet Acknowledge an SDA, zur Bestaetigung empfangener Bytes    
;-------------------------------------------------------------------------------------------------------------------------

ACK:		call	waitus
		clr	SDA			;SDA auf Low
		call	CLOCK			;und Clock erzeugen
		ret


;------------------------------------ Low Level ------------ I2C BUS --------------------------------------------------
;  NACKNOWLEDGE                                                     
;                                                                       
;      IN:                                                              
;      OUT:                                                             
;      VERAENDERT:  C                                                   
;                                                                       
;      Sendet No-Acknowledge an SDA zur Bestaetigung empfangener Bytes  
;------------------------------------------------------------------------------------------------------------------------------

NACK:		call	waitus
		setb	SDA			;SDA auf High
		call	CLOCK			;und Clock erzeugen
		ret

;########################################################################
;	Warteschleife
;	(mit mehreren Einsprungmarken)
;	VR: r2,r3 haben am Ende den Wert 0
;########################################################################

wait5:		mov	r2,#12			; ca. 5 Millisekunden
		sjmp	wait

wait50:		mov	r2,#122			; ca. 50 ms
		sjmp	wait

waitmx:		mov	r2,#0

wait:		mov	r3,#0

wt_1:		djnz	r3,wt_1
		djnz	r2,wait

ret1:		ret

;-----------------------------------------------------------------------------------------------------------------------------------

txtQRT:		db	"aus"

;		db	" sch"
;		db	82h
;		db	"ss "			; Nullbyte als Endekennzeichen wird durch nachfolgenden
						; NOP-Befehl gebildet!

;************************************************************************
; wenige Mikrosekunden vertrdeln (fr I2C-Geschwindigkeitsanpassung)
;**************************************************************************

waitus:		nop				; NOP ist auch String-Ende!
		nop
		jnb	btSlowI2C,ret1
		push	acc
		push	b
		push	psw
		mul	ab
		mul	ab
		mul	ab
		mul	ab
		pop	psw
		pop	b
		pop	acc
		sjmp	ret1
	
;----------------------------------------------------------------------
; Texte
;----------------------------------------------------------------------

txtVolum:	db	"Volume"
		db	0

txtSquel:	db	"Squelch"
		db	0

txtMemWr:	db	"WriteMem"
		db	0

txtFreq:	db	"QRG:    43*.***"
		db	0

txtTxPwr:	db	"TxPower"
		db	0

txtShift:	db	"RelShift"
		db	0

txtLicht:	db	"Light   save"
		db	0

txtMemVF:	db	"Mem->VFO"
		db	0

txtInit:	db	"Init    EEPROM"
		db	0

txtFertg:	db	"Done"
		db	0

txtUAlrm:	db	"Low Batt"
		db	0

txtMemTxt:	db	"MemoText"
		db	0

;********************************************************************
; Tabelle mit Duplex-Ablagen       1=12,5 Khz also 6550 KHz/12,5 KHz=524=20C-1 Hex
;********************************************************************

dupTable:	; Eintrag 0: keine Ablage	
		db	0
		db	0
		; Eintrag 1: -7.6 MHz -> -0x0260=0xFDA0
		db	0a0h
		db	0fdh
		; Eintrag 2: +7.6 MHz -> 0x0260
		db	060h
		db	002h
		; Eintrag 3: -9.4 MHz -> -0x02f0=0xFD10
		db	010h
		db	0fdh
		; Eintrag 4: +9.4 MHz -> 0x02f0
		db	0f0h
		db	002h
		; Eintrag 5: -6.55 MHz -> -0x020B=0xFDF4
		db	0F4h
		db	0fdh
		; Eintrag 6: +6.55 MHz -> 0x020C
		db	00Ch
		db	002h
		; Eintrag 7: +1.6 MHz -> 0x0080
		db	080h
		db	000h
		; Eintrag 8: -1.6 MHz -> -0x0080=FF80
		db	080h
		db	0FFh

TxtDup:		db	"+-0.00"
		db	"-7.600"
		db	"+7.600"
		db	"-9.400"
		db	"+9.400"
		db	"-6.550"
		db	"+6.550"
                db      "+1.600"
                db      "-1.600"

CharTab:	db	"., !?#0"
		db	"ABC1abc"
		db	"DEF2def"
		db	"GHI3ghi"
		db	"JKL4jkl"
		db	"MNO5mno"
		db	"PQR6pqr"
		db	"STU7stu"
		db	"VWX8vwx"
		db	"YZ/9yz-"

DTMFtab:	db	"123"
		db	3fh			; up
		db	"456"
		db	4bh			; left
		db	"789"
		db	3dh			; down
		db	"*0#"
		db	21h			; right

;************************************************************************
; EEPROM mit Standardwerten initialisieren
;************************************************************************

EeInit:		mov	DPTR,#txtInit
		call	eintrTxt
		call	BusRQ
		call	sendStc

		mov	r0,#8			; Anzahl Bytes
		mov	DPTR,#EeDataF0		; Quelle
		mov	w_adr,#0f0h		; Ziel im EEPROM (Gerteparameter)
Ee_01:		clr	a
		movc	a,@a+DPTR
		call	EEP_RWR
		inc	w_adr
		inc	DPTR
		djnz	r0,Ee_01

		mov	r0,#60			; Anzahl Bytes 9xBank0 + 1xBank1
		mov	DPTR,#EeData00		; Quelle
		mov	w_adr,#0		; Ziel im EEPROM
Ee_02:		clr	a
		movc	a,@a+DPTR
		call	EEP_RWR
		inc	w_adr
		inc	DPTR
		djnz	r0,Ee_02

; restliche Speicherpltze auf 430.000 und "????" einstellen
                mov	r0,#26		; Anzahl Speicherpltze
		mov	w_adr,#60	; Zieladresse
Ee_03:		mov	a,#20h
		call	EEP_RWR
		inc	w_adr
		mov	a,#03h
		call	EEP_RWR
		inc	w_adr
		push	0
		mov	r0,#4
Ee_03a:		mov	a,#'?'
		call	EEP_RWR
		inc	w_adr
		djnz	r0,Ee_03a
		pop	0
		djnz	r0,Ee_03
; Fertigmeldung
		mov	DPTR,#txtFertg
		call	eintrTxt
		call	BusRQ
		call	sendStc
		call	wait50

		call	vorbTon
		call	busRQ
		call	sendStc
		mov	r0,#100			; 5 Sekunden
Ee_04:		call	wait50
		djnz	r0,Ee_04
						; ausschalten
		jmp	aus

EeDataF0:	db	20			; squelch
		db	1			; volume: leise
		db	80h			; Lichtmodus, memPage, memNr
		db	1			; txPwr
		db	2			; tuneStep 25 kHz
		db	50			; AD-Wert fr S-Meter-Nullpunkt
		dw	061fh			; VFO 439.587
                db      0                       ;

EeData00:	;dw = die ersten 4 Bit sind die Ablagen
        ; --- Bank 0 ---
        ; Mem 01
        dw      15d6h ; 438.675  -7.6 (Collm/hb9hai?)
        db      "9hai"
        ; Mem 02
        dw      15dch ; 438.750  -7.6 (Sntis)
        db      "saen"
        ; Mem 03
        dw      15e0h ; 438.800  -7.6 (Pilatus)
        db      "   p"
        ; Mem 04
        dw      15e4h ; 438.850  -7.6 (Zugspitze)
        db      "zugs"
        ; Mem 05
        dw      15e6h ; 438.875  -7.6 (Dresden/Pfnder)
        db      "pfae"
        ; Mem 06
        dw      15e8h ; 438.900  -7.6 (Feldberg)
        db      "  fb"
        ; Mem 07
        dw      15f0h ; 439.000  -7.6 (db0zd)
        db      "  zd"
        ; Mem 08
        dw      15fah ; 439.125  -7.6 (?)
        db      "    "
        ; Mem 09
        dw      0400h ; 432.800 +-0
        db      "    "
        ; --- Bank1 ---
        ; Mem 11
        dw      15b0h ; 438.200  -7.6 (Pfnder PR 1k2)
        db      " xpr"


txtOn:		db	" Hallo  "
		db	"C5-V.9d "
		db	0

txtCopyr:	db	"20010704byDL6INT"
		db	0


;************************************************************************
;*****     D a s     w a r ' s      *************************************
;************************************************************************


