/*************************************************************************
 *
 * Siemens C5 
 *
 * Testprogramm (Emulator)
 *
 * (c) Thomas Mller, 2001
 *
 * $RCSfile: c5win.c $
 * $Revision: 1.7 $
 * $Date: 2001/03/27 20:31:21 $
 *
 */

#include <Windows.H>
#include <stdio.h>
#include "c5win.h"
#include "c5_c.h"
#include "c5font.h"

#define MAX_AUSBUFFER 17
#define MAX_TXBUFFER  0x1d

char stellen;
char crs_pos;
char crs_buf;
char hour;
char min;
char sec;
char day;
char mon;
char year;
char hsec;
char hsec_alt;
char buf1cc7h[MAX_AUSBUFFER];
char txbuffer[MAX_TXBUFFER];
char empfbuffer1[MAX_TXBUFFER];
char telegrnummer1;
char empfbuffer2[MAX_TXBUFFER];
char telegrnummer2;
char empfbuffer3[MAX_TXBUFFER];
char telegrnummer3;
char addr_seg;
int addr_off;
char addr_val;
char addr_val_new;
char addr_ch;
char msgbuffer[];
char bfbusmode;
char stern;
char modus;
char ausgeben;
char volume;
char squelch;
char tunestep;
int temperatur;

char i2c_control;
char i2c_richtung;
char i2c_buffer_pt;
char i2c_buffer_in[];
char i2c_buffer_out[];
char i2c_buffer_anz;
char ad_wandler_ctrlbyte;

char io_e002;
char io_e003;
char pt;

#define ESC_TASTE 27

/* Anzeige */
/* ------- */
/* Pixelbreite */
#define PIX_X  3
/* x-Abstand zwischen Pixeln */
#define ZWRP_X 1
/* x-Abstand zwischen Zeichen */
#define ZWRZ_X 4

/* Pixelhoehe */
#define PIX_Y  3
/* y-Abstand zwischen Pixeln */
#define ZWRP_Y 1
/* y-Abstand zwischen Zeichen */
#define ZWRZ_Y 4

HFONT hfont, hfontOld;
HBRUSH b_hbr;
HBRUSH fb_hbr;
HBRUSH fg_hbr;
HPEN fb_pen;
HPEN fb_pen2;
HPEN fg_pen;
HPEN fg_pen2;

HBITMAP kreis_an_bmp;
HBITMAP kreis_aus_bmp;
int kreis_an = FALSE;

HBITMAP schluessel_an_bmp;
HBITMAP schluessel_aus_bmp;
int schluessel_an = FALSE;

HBITMAP links_an_bmp;
HBITMAP links_aus_bmp;
int pfeillinks_an = FALSE;

HBITMAP rechts_an_bmp;
HBITMAP rechts_aus_bmp;
int pfeilrechts_an = FALSE;

HBITMAP laut_an_bmp;
HBITMAP laut_aus_bmp;
int lautsprecher_an = FALSE;

HBITMAP hoerer_an_bmp;
HBITMAP hoerer_aus_bmp;
int hoerer_an = FALSE;

HBITMAP rahmen_an_bmp;
HBITMAP rahmen_aus_bmp;
int rahmen_an = FALSE;

HBITMAP feld_an_bmp;
HBITMAP feld_aus_bmp;
int feld_an[5] = {FALSE, FALSE, FALSE, FALSE, FALSE};

HBITMAP rtae_an_bmp;
HBITMAP rtae_aus_bmp;
int rtae_an = FALSE;

HBITMAP tae_an_bmp;
HBITMAP tae_aus_bmp;
int tae_an = FALSE;

long FAR PASCAL C5WndProc(HWND, unsigned, WORD, LONG);
static void DrawBitmap( HDC, HBITMAP, short, short );

/*************************************************************************
 * WINMAIN 
 *
 * in:
 * out:
 * ret:
 *
 */
int PASCAL WinMain (HANDLE hInstance,
                    HANDLE hPrevInstance,
                    LPSTR lpszCmdLine,
                    int cmdShow)
{
    HWND hwnd;
    MSG msg;
    WNDCLASS wndclass;
    int iPtSize = 18;
    PSTR pszFace = "Lucida Console";

    if (!hPrevInstance)
        {
        wndclass.lpszClassName = "C5Win:MAIN";
        wndclass.hInstance = hInstance;
        wndclass.lpfnWndProc = C5WndProc;
        /* wndclass.hCursor = LoadCursor(hInstance, "hand"); */
        wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
        wndclass.hIcon = LoadIcon(hInstance, "snapshot");
        wndclass.lpszMenuName = NULL;
        /*
        wndclass.lpszMenuName = "WinBitMenu";
        wndclass.hbrBackground = COLOR_WINDOW + 1;
        */
        wndclass.hbrBackground = GetStockObject( WHITE_BRUSH );
        wndclass.style = CS_HREDRAW | CS_VREDRAW;
        wndclass.cbClsExtra = 0;
        wndclass.cbWndExtra = 0;
        RegisterClass(&wndclass);
        }

    /* MapModePrevious = SetMapMode(hdc, MM_TWIPS); */
    hfont = CreateFont(-iPtSize, 0, 0, 0, 0, /* specify pt size    */
        0, 0, 0, 0, 0, 0, 0, 0, pszFace);         /* and face name only */
    /* SetMapMode(hdc, MapModePrevious); */

    b_hbr = CreateSolidBrush(RGB(225, 225, 0));
    fb_hbr = CreateSolidBrush(RGB(0, 0, 0));
    fb_pen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
    fb_pen2 = CreatePen(PS_SOLID, 2, RGB(0, 0, 0));
    fg_hbr = CreateSolidBrush(RGB(210, 210, 0));
    fg_pen = CreatePen(PS_SOLID, 1, RGB(210, 210, 0));
    fg_pen2 = CreatePen(PS_SOLID, 2, RGB(210, 210, 0));

    hsec = 0;
    sec = 0;
    min = 0;
    hour = 0;
    day = 1;
    mon = 1;
    year = 1;

    pt = 0x7d;
    stellen = 2;
    crs_pos = 0;
    addr_ch = 0;
    addr_val = 0;
    addr_val_new = 0;
    addr_seg = 0;
    addr_off = 0x1004;
    stern = '*';
    bfbusmode = 4;
    modus = 0;
    volume = 0x80;
    squelch = 0x80;
    tunestep = 125;
    temperatur = 0;

    gib_modus_aus();

    hwnd = CreateWindow("C5Win:MAIN",
                        "C5",
                        WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT,
                        CW_USEDEFAULT,
                        30 + 8 * (5 * PIX_X + 4 * ZWRP_X) + 7 * ZWRZ_X,
                        2 * (30 + 2 * (7 * PIX_Y + 6 * ZWRP_Y) + ZWRZ_Y),
                        NULL,
                        NULL,
                        hInstance,
                        NULL
                        );

    kreis_an_bmp = LoadBitmap(hInstance, "kreis_an_bmp" );
    kreis_aus_bmp = LoadBitmap(hInstance, "kreis_aus_bmp" );
    schluessel_an_bmp = LoadBitmap(hInstance, "schluessel_an_bmp" );
    schluessel_aus_bmp = LoadBitmap(hInstance, "schluessel_aus_bmp" );
    links_an_bmp = LoadBitmap(hInstance, "links_an_bmp" );
    links_aus_bmp = LoadBitmap(hInstance, "links_aus_bmp" );
    rechts_an_bmp = LoadBitmap(hInstance, "rechts_an_bmp" );
    rechts_aus_bmp = LoadBitmap(hInstance, "rechts_aus_bmp" );
    laut_an_bmp = LoadBitmap(hInstance, "laut_an_bmp" );
    laut_aus_bmp = LoadBitmap(hInstance, "laut_aus_bmp" );
    hoerer_an_bmp = LoadBitmap(hInstance, "hoerer_an_bmp" );
    hoerer_aus_bmp = LoadBitmap(hInstance, "hoerer_aus_bmp" );
    rahmen_an_bmp = LoadBitmap(hInstance, "rahmen_an_bmp" );
    rahmen_aus_bmp = LoadBitmap(hInstance, "rahmen_aus_bmp" );
    feld_an_bmp = LoadBitmap(hInstance, "feld_an_bmp" );
    feld_aus_bmp = LoadBitmap(hInstance, "feld_aus_bmp" );
    rtae_an_bmp = LoadBitmap(hInstance, "rtae_an_bmp" );
    rtae_aus_bmp = LoadBitmap(hInstance, "rtae_aus_bmp" );
    tae_an_bmp = LoadBitmap(hInstance, "tae_an_bmp" );
    tae_aus_bmp = LoadBitmap(hInstance, "tae_aus_bmp" );

    ShowWindow(hwnd, cmdShow);
    UpdateWindow(hwnd);

    SetTimer(hwnd, 1, 500, NULL);

    while(GetMessage(&msg, 0, 0, 0))
        {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
        }

    /* SelectObject(hdc, hfontOld); */
    DeleteObject(hfont);

    return(0);
}

/*************************************************************************
 * PIXELWNDPROC
 *
 * in:
 * out:
 * ret:
 *
 */
long FAR PASCAL C5WndProc(HWND hWnd, WORD msg, WORD wParam, LONG lParam)
{
    PAINTSTRUCT ps;

    switch (msg)
        {
        case WM_DESTROY:
            /* KillTimer(); */
            PostQuitMessage(0);
            break;

        case WM_KEYDOWN:
            {
            int c;

            /* mehrfach druecken abfangen */
            /*
            if (LOWORD(lParam) & 0x4000 != 0)
                break;
                */

            c = c5test_getTaste(LOWORD(wParam));

            if ((pt & 4) == 0)
                PostQuitMessage(0);

            if (c != 0)
                {
                taste_bearbeiten(c);
                gib_modus_aus();

                InvalidateRect(hWnd, NULL, TRUE);
                }
            }
            break;
        case WM_TIMER:
            hsec ++;

            if (hsec == 2)
                {
                hsec = 0;
                sec ++;
                temperatur = sec;

                if (sec == 60)
                    {
                    sec = 0;
                    min ++;

                    if (min == 60)
                        {
                        min = 0;
                        hour ++;

                        if (hour == 24)
                            {
                            hour = 0;
                            day ++;

                            if (day == 32)
                                {
                                day = 1;
                                mon ++;

                                if (mon == 13)
                                    {
                                    mon = 1;
                                    year ++;

                                    if (year == 100)
                                        year = 0;
                                    }
                                }
                            }
                        }
                    }
                }

            if ((modus == M_TIME) || (modus == M_MONITOR) ||
                    (modus == M_UBATT))
                {
                gib_modus_aus();
                InvalidateRect(hWnd, NULL, TRUE);
                }

            break;

        case WM_COMMAND:
            switch (LOWORD(wParam))
                {
                /*
                case IDM_UEBER:
                    proc = MakeProcInstance( AboutDlgProc, MyInstance );
                    DialogBox( MyInstance,"AboutBox", hWnd, proc );
                    FreeProcInstance( proc );
                    break;
                    */
                case IDM_PREV:
                    break;

                case IDM_NEXT:
                    break;

                case IDM_GOTO:
                    break;

                case IDM_BEENDEN:
                    DestroyWindow(hWnd);
                    break;
                }
            break;

        case WM_PAINT:
            {
#ifdef MIT_FONT
            char bfeld_no_str[25];
#endif
            int i;
            HBRUSH hbrOld;

            BeginPaint(hWnd, &ps);

            FillRect(ps.hdc, &ps.rcPaint, b_hbr);

#ifdef MIT_FONT
            SetTextColor(ps.hdc, RGB(0,0,0));
            SetBkMode(ps.hdc, TRANSPARENT);
            SelectObject(ps.hdc, hfont);

            strncpy(bfeld_no_str, &txbuffer[4], 8);
            bfeld_no_str[8] = 0;
            c5test_zeichen(bfeld_no_str);
            TextOut(ps.hdc, 11, 5, bfeld_no_str, strlen(bfeld_no_str));

            strncpy(bfeld_no_str, &txbuffer[12], 8);
            bfeld_no_str[8] = 0;
            c5test_zeichen(bfeld_no_str);
            TextOut(ps.hdc, 11, 20, bfeld_no_str, strlen(bfeld_no_str));

            SetTextColor(ps.hdc, RGB(128,128,128));

            sprintf(bfeld_no_str, "os <> lh");
            TextOut(ps.hdc, 11, 35, bfeld_no_str, strlen(bfeld_no_str));
            sprintf(bfeld_no_str, "#####TAE");
            TextOut(ps.hdc, 11, 50, bfeld_no_str, strlen(bfeld_no_str));
#else
            hbrOld = SelectObject(ps.hdc, fb_hbr);

            for (i = 0; i < 16; i++)
                draw_char(ps.hdc, i, txbuffer[4 + i]);

            if (kreis_an)
                DrawBitmap(ps.hdc, kreis_an_bmp, 10, 75);
            else
                DrawBitmap(ps.hdc, kreis_aus_bmp, 10, 75);

            if (schluessel_an)
                DrawBitmap(ps.hdc, schluessel_an_bmp, 40, 80);
            else
                DrawBitmap(ps.hdc, schluessel_aus_bmp, 40, 80);

            if (pfeillinks_an)
                DrawBitmap(ps.hdc, links_an_bmp, 78, 75);
            else
                DrawBitmap(ps.hdc, links_aus_bmp, 78, 75);

            if (pfeilrechts_an)
                DrawBitmap(ps.hdc, rechts_an_bmp, 110, 75);
            else
                DrawBitmap(ps.hdc, rechts_aus_bmp, 110, 75);

            if (lautsprecher_an)
                DrawBitmap(ps.hdc, laut_an_bmp, 145, 76);
            else
                DrawBitmap(ps.hdc, laut_aus_bmp, 145, 76);

            if (hoerer_an)
                DrawBitmap(ps.hdc, hoerer_an_bmp, 169, 75);
            else
                DrawBitmap(ps.hdc, hoerer_aus_bmp, 169, 75);

            if (rahmen_an)
                DrawBitmap(ps.hdc, rahmen_an_bmp, 10, 100);
            else
                DrawBitmap(ps.hdc, rahmen_aus_bmp, 10, 100);

            for (i = 0; i < 5; i++)
                {
                if (feld_an[i])
                    DrawBitmap(ps.hdc, feld_an_bmp, 12 + i * 25, 102);
                else
                    DrawBitmap(ps.hdc, feld_aus_bmp, 12 + i * 25, 102);
                }

            if (rtae_an)
                DrawBitmap(ps.hdc, rtae_an_bmp, 150, 100);
            else
                DrawBitmap(ps.hdc, rtae_aus_bmp, 150, 100);

            if (tae_an)
                DrawBitmap(ps.hdc, tae_an_bmp, 151, 101);
            else
                DrawBitmap(ps.hdc, tae_aus_bmp, 151, 101);

            SelectObject(ps.hdc, hbrOld);
#endif
            EndPaint(hWnd, &ps);
            }
            break;
        default:
            return(DefWindowProc(hWnd,msg,wParam,lParam));
            break;
        }
    return(0L);
}

/*************************************************************************
 * DRAW_CHAR
 *
 * in:
 * out:
 * ret:
 *
 */
void draw_char(HDC hdc, int pos, char c)
{
    int yoff = 0;
    int i = pos;
    int j;
    int x1, y1;
    int xo, yo;

    if ((c < 0x20) || (c > 0x91))
        return;

    if (i >= 8)
        {
        yoff = 7 * PIX_Y + 6 * ZWRP_Y + ZWRZ_Y;
        i -= 8;
        }

    x1 = 10 + i * (5 * PIX_X + 4 * ZWRP_X + ZWRZ_X);
    y1 = 10 + yoff;
    /*
    x2 = x1 + (5 * PIX_X + 4 * ZWRP_X);
    y2 = y1 + (7 * PIX_Y + 6 * ZWRP_Y);

    Rectangle(hdc, x1, y1, x2, y2);
    */

    for (i = 0; i < 7; i++)
        {
        for (j = 0; j < 5; j++)
            {
            if (font[(c - 0x20) * 7 + i][j] == '#')
                {
                SelectObject(hdc, fb_hbr);
                SelectObject(hdc, fb_pen);
                xo = x1 + j * (PIX_X + ZWRP_X);
                yo = y1 + i * (PIX_Y + ZWRP_Y);
                Rectangle(hdc, xo, yo, xo + PIX_X, yo + PIX_Y);
                }
            else
                {
                SelectObject(hdc, fg_hbr);
                SelectObject(hdc, fg_pen);
                xo = x1 + j * (PIX_X + ZWRP_X);
                yo = y1 + i * (PIX_Y + ZWRP_Y);
                Rectangle(hdc, xo, yo, xo + PIX_X, yo + PIX_Y);
                }
            }
        }
}

/*
 * display a bitmap on the given DC, at device coordinates x,y
 * make the bitmap the same size as the source bitmap
 */
static void DrawBitmap( HDC hdc, HBITMAP bitmap, short x, short y )
/*****************************************************************/
{
    BITMAP      bitmapbuff;
    HDC         memorydc;
    POINT       origin;
    POINT       size;

    memorydc = CreateCompatibleDC( hdc );
    SelectObject( memorydc, bitmap );
    SetMapMode( memorydc, GetMapMode( hdc ) );
    GetObject( bitmap, sizeof( BITMAP ), (LPSTR) &bitmapbuff );

    origin.x = x;
    origin.y = y;
    size.x = bitmapbuff.bmWidth;
    size.y = bitmapbuff.bmHeight;

    DPtoLP( hdc, &origin, 1 );
    DPtoLP( memorydc, &size, 1 );

    BitBlt( hdc, origin.x, origin.y, size.x, size.y, memorydc, 0, 0, SRCCOPY);
    DeleteDC( memorydc );
} /* DrawBitmap */

/*************************************************************************
 * C5TEST_PRINT_TXBUFFER
 *
 * in:
 * out:
 * ret:
 *
 */
void c5test_print_txbuffer(void)
{
    int i;
    int c;

    printf("TxBuffer:|");

    for (i=0; i < txbuffer[2]; i++)
        {
        c = txbuffer[i];

        if (isprint(c))
            printf("%c", c);
        else
            printf(".");
        }

    printf("|\n");

    for (i=0; i < txbuffer[2]; i++)
        {
        c = txbuffer[i];
        printf(" %.2x", c);

        if (isprint(c))
            printf("(%c)", c);
        }
    printf("\n");
}

/*************************************************************************
 * C5TEST_GETTASTE
 *
 * in:
 * out:
 * ret:
 *
 */
int c5test_getTaste(WORD c)
{
    int ret = 0;

    switch (c)
        {
        case 0x30:
        case 0x31:
        case 0x32:
        case 0x33:
        case 0x34:
        case 0x35:
        case 0x36:
        case 0x37:
        case 0x38:
        case 0x39:
            ret = c;
            break;
        case 0x43:
            ret = C_TASTE;
            break;
        case 187:
            ret = STERN_TASTE;
            break;
        case 188:
            ret = DPLPUNKT_TASTE;
            break;
        case 89:
            ret = HOERER_TASTE;
            break;
        case 190:
            ret = PUNKT_TASTE;
            break;
        case 191:
            ret = RAUTE_TASTE;
            break;
        case VK_UP:
            ret = HOCH_TASTE;
            break;
        case VK_DOWN:
            ret = RUNTER_TASTE;
            break;
        case VK_RIGHT:
            ret = RECHTS_TASTE;
            break;
        case VK_LEFT:
            ret = LINKS_TASTE;
            break;
        case VK_ESCAPE:
            pt = 0x79;
            break;
        }

    return(ret);
}

/*************************************************************************
 * C5TEST_ZEICHEN
 *
 * in:
 * out:
 * ret:
 *
 */
void c5test_zeichen(char *text)
{
    int i;

    for (i = 0; i < strlen(text); i++)
        {
        switch (text[i])
            {
            case 0x7f :
                text[i] = '#';
                break;
            case 0x87 :
                text[i] = '>';
                break;
            }
        }
}

/*************************************************************************
 * POKE
 *
 * in:
 * out:
 * ret:
 *
 */
void poke(void)
{
    addr_val = addr_val_new;

    if (addr_seg == 0)
        {
        switch (addr_off)
            {
            case 0x1004:
                sec = addr_val_new;
                break;
            case 0x1005:
                min = addr_val_new;
                break;
            case 0x1006:
                hour = addr_val_new;
                break;
            case 0x1009:
                crs_pos = addr_val_new;
                break;
            case 0x100a:
                crs_buf = addr_val_new;
                break;
            }
        }
}

/*************************************************************************
 * PEEK
 *
 * in:
 * out:
 * ret:
 *
 */
void peek(void)
{
    if (addr_seg == 0)
        {
        switch (addr_off)
            {
            case 0x1004:
                addr_val = sec;
                break;
            case 0x1005:
                addr_val = min;
                break;
            case 0x1006:
                addr_val = hour;
                break;
            case 0x1009:
                addr_val = crs_pos;
                break;
            case 0x100a:
                addr_val = crs_buf;
                break;
            }
        }
}

/*************************************************************************
 * SENDE_ZUM_BFBUS
 *
 * eigentlich eine ASM-Routine
 *
 * in:
 * out:
 * ret:
 *
 */
void sende_zum_bfbus(void)
{
}

/*************************************************************************
 * I2C_AUSGABE
 *
 * in:
 * out:
 * ret:
 *
 */
void i2c_ausgabe()
{
    i2c_control &= 0xf7;
}
